;   le batch pour batir une librairie
;batch,sources et .inc (contenant les proto)

; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive
      ; --------------------------------
      ; Les fichiers inclus ii
      ; --------------------------------
       include \masm32\include\windows.inc
       include \masm32\include\kernel32.inc
       include \masm32\include\user32.inc
       include \masm32\include\masm32.inc
	include macros.txt

      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------

      	EXTERNDEF InfosFichiers:WIN32_FIND_DATA 
	EXTERNDEF SetTestFichier:PROTO :DWORD
	EXTERNDEF OuvrirLecture:PROTO :DWORD

    .code
;################################################################

 ChargerFichierMem proc NomAediter:DWORD,PileMem:DWORD
		LOCAL retour:DWORD
		LOCAL fichier:DWORD
          ;pilemem adresse d'une structure
	   ;rajoute un zero en fin de fichier
	   ;ncessaire dans les copies avec clipboard par exemple
	   ;utilise  WIN32_FIND_DATA et NomComplet
	
	;FichMem    struc
	;	Hmem     dd ?
	;	Mpoint   dd ?
	;	Taille   dd ?
	;FichMem    ends 


		local hMemory:DWORD
		local pMemory:DWORD
		local hFile:DWORD
		local NbOctetsaLire:DWORD
		local NbOctetsLus:DWORD
	PUSHAD
	InsTxt ercharge,"Taille ",0
	InsTxt texthou," Handle fichier ",0
	InsTxt textHmem,"Handle memoire ",0
	InsTxt textPm,"Pointeur memoire ",0
	InsTxt textlu," Nb octets en lecture ",0

	invoke SetTestFichier,NomAediter	   	
	.if eax==FALSE        
		mov retour,0
		jmp FindeChargerFichierMem
	.else
		mov fichier,eax
	.endif
	mov ebx,PileMem 

	;----------------------------
	;  ouvrir le fichier
	;----------------------------
	invoke OuvrirLecture,fichier
	.if eax==INVALID_HANDLE_VALUE
		invoke  MessageBox,NULL,SADD(" Erreur d'ouverture Fichier "),\
					SADD("ChargerFichierMem"),MB_OK
		mov retour,0
		jmp FindeChargerFichierMem
	.endif 
	mov hFile,eax 

	;-------------------------
	;obtenir le handle de mmoire, taille du fichier dw 
	;-------------------------
	mov ecx,InfosFichiers.nFileSizeLow
	mov dword ptr (FichMem ptr [ebx]).Taille,ecx
	inc ecx		;pour rajouter le zero en fin de fichier
	invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_ZEROINIT,ecx
					
	.if eax == 0
		invoke  MessageBox,NULL,SADD("Pas assez de place mmoire "),\
					SADD("GlobalAlloc"),MB_OK
		mov retour,0
		jmp FindeChargerFichierMem
	.endif            
	mov  hMemory,eax
	mov dword ptr (FichMem ptr [ebx]).Hmem,eax
	;obtenir le pointeur de memoire
	invoke GlobalLock,hMemory
	mov  pMemory,eax
	mov dword ptr (FichMem ptr [ebx]).Mpoint,eax

	mov eax,InfosFichiers.nFileSizeLow  
	mov NbOctetsaLire,eax
	invoke ReadFile,hFile,pMemory,NbOctetsaLire,addr NbOctetsLus,NULL
			
	;-------------------------
	;libr la memoire ,ferm le fichier ouvert
	;-------------------------
		; invoke GlobalUnlock,pMemory
		; invoke GlobalFree,hMemory
	invoke CloseHandle,hFile
		mov retour,1
FindeChargerFichierMem:
		popad
		mov eax,retour
		ret
ChargerFichierMem endp

;#########################################################################


end