
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

       include \masm32\include\windows.inc
       include \masm32\include\user32.inc
       include \masm32\include\kernel32.inc
       include \masm32\include\masm32.inc
	include macros.txt	
	
	;viter les redfinitions de symboles,ajouter imagehlp dans le source
	
	SymGetOptions PROTO 
	
	; reois le chemin de la librairie dbghelp.dll pour chargement dynamique
	;InstalleExceptions PROTO :DWORD

      ; 
      ;exemples de definitions externes
       	EXTERNDEF Copier :PROTO  :DWORD,:DWORD
      ; 	EXTERNDEF EtatMemoirePile :MEMORY_BASIC_INFORMATION 
      ; 	EXTERNDEF PoriginePile:DWORD
		EXTERNDEF RetrouveMessageErreur : PROTO  :DWORD
			    	
   .const
;----------------------------------- declarations exceptions -----------------------------------------------
EXCEPTION_NONCONTINUABLE_EXCEPTION 	TEXTEQU	 	<STATUS_NONCONTINUABLE_EXCEPTION>
EXCEPTION_STACK_OVERFLOW      		TEXTEQU	      	<STATUS_STACK_OVERFLOW>
EXCEPTION_INVALID_DISPOSITION  		TEXTEQU	     	<STATUS_INVALID_DISPOSITION>
EXCEPTION_GUARD_PAGE           		TEXTEQU	     	<STATUS_GUARD_PAGE_VIOLATION>

	FINAL_HANDLER 			PROTO  :DWORD
	HANDLER				PROTO  :DWORD,:DWORD,:DWORD,:DWORD
	DebugExcept				PROTO 
	DlgDebugExcept   			PROTO  :DWORD,:DWORD,:DWORD,:DWORD
	AffichageException 			PROTO  :DWORD,  :DWORD 
	; proto symboles
	EnumModulesCallback 			PROTO  :DWORD,  :DWORD,  :DWORD ; 
	EnumSourceFilesCallback 		PROTO  :DWORD,  :DWORD ;
	CallbackEnumerateSymbols 		PROTO  :DWORD,  :DWORD,  :DWORD ,:DWORD ;
	SymEnumLinesProc  			PROTO  :DWORD,:DWORD		;ok
	InitialisationSymboles 		PROTO ;
	AfficheRegistre 			PROTO  :DWORD,  :DWORD
	InitialiseSymPath 			PROTO 
	ExplorePile 				PROTO  :DWORD
	remontepile 				PROTO  :DWORD,:DWORD,:DWORD
	DescendrePile 			PROTO  :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	LireMemoire				PROTO  :DWORD,  :DWORD,  :DWORD ,:DWORD, :DWORD
	TableAccess 				PROTO  :DWORD,  :DWORD 
	BaseModule				PROTO  :DWORD,  :DWORD
	Minidump 				PROTO 
	ThreadMinidump 			PROTO  :DWORD
	OuvrirEcriturew     			PROTO  :DWORD	
	ExcEnvoyerServeurDDE 		PROTO  :DWORD,  :DWORD , :DWORD


 IDC_EXCEPTBUTTON1	 equ 3096
 IDC_EXCEPTEDIT1      equ 3097
 IDC_EXCEPTETIDASM	 equ 3098
 IDC_EXCEPTETIEAX	 equ 3099
 IDC_EXCEPTETIEBX	 equ 3100
 IDC_EXCEPTETIECX	 equ 3101
 IDC_EXCEPTETIEDI	 equ 3102
 IDC_EXCEPTETIEDX	 equ 3103
 IDC_EXCEPTETIEIP	 equ 3104
 IDC_EXCEPTETIESI	 equ 3105
 IDC_EXCEPTETIESP	 equ 3106
 IDC_EXCEPTETIFAUTE	 equ 3107
 IDC_EXCEPTETIEBP     equ 3108
 IDC_EXCEPTETIFLAG1   equ 3109
 IDC_EXCEPTETIFLAG2   equ 3110
 IDC_STATIC	equ	-1


MINIDUMP_EXCEPTION_INFORMATION struct
     ThreadId DWORD ?;
     ExceptionPointers DWORD ?;
     ClientPointers BYTE ?;
MINIDUMP_EXCEPTION_INFORMATION ends
	
    MiniDumpNormal                         equ 0000h
    MiniDumpWithDataSegs                   equ 0001h
    MiniDumpWithFullMemory                 equ 0002h
    MiniDumpWithHandleData                 equ 0004h
    MiniDumpFilterMemory                   equ 0008h
    MiniDumpScanMemory                     equ 0010h
    MiniDumpWithUnloadedModules            equ 0020h
    MiniDumpWithIndirectlyReferencedMemory equ 0040h
    MiniDumpFilterModulePaths              equ 0080h
    MiniDumpWithProcessThreadData          equ 0100h
    MiniDumpWithPrivateReadWriteMemory     equ 0200h
    MiniDumpWithoutOptionalData            equ 0400h
	SYMOPT_ALLOW_ABSOLUTE_SYMBOLS   	  equ 00800h


	ExceptInsTxt MACRO Name, Text:VARARG
	LOCAL lbl
		jmp lbl
		Name db Text,0
	lbl:
	ENDM
	EXCPERMUTTEHIGHLOW MACRO registre   ;ne pas utiliser edx
		push edx
		mov edx,registre
		and edx,0FFFFh
		shl edx,16
		and registre,0FFFF0000h
		shr registre,16
		add registre,edx
		pop edx
	ENDM
      ExceptCreateData MACRO quoted_text:VARARG
        LOCAL Local_Etiquette
        .data
          Local_Etiquette db quoted_text,0
        .code
        EXITM <Local_Etiquette>
      ENDM
	EXCEPTHIWORD MACRO ParamFen
		mov eax,ParamFen
		shr eax,16
	ENDM
	EXCEPTLOWORD MACRO ParamFen
		mov eax,ParamFen
		and eax,0FFFFh
	ENDM
      excPuPo MACRO M1, M2
        push M2
        pop  M1
      ENDM

	EXCZEROLOCALES MACRO dernierelocale:REQ  ;met les locales en pile a zro
		mov ecx,ebp
		lea edx,dernierelocale
		sub ecx,edx
		.if ecx != 0
			push edi
			mov edi,edx
			mov al,0
			cld
			rep stosb
			pop edi			
		.endif
	ENDM


;le tableau de renseignements dans la pile se prsente ainsi,noms indicatifs
;
;	retour:DWORD 			;prserve la valeur de retour du proc si russite
;	Basepointeur:DWORD		;la valeur originale de EBP
;	adrInvoke:DWORD		;adresse de invoke
;	NomGenerique:DWORD		;la phrase gnrique permettant de localiser l'erreur dans le source
;	adrAbandonProc:DWORD		;l'adresse de retour si on choisit de passer l'execution du proc
;	adrHANDLER:DWORD		;ERR_+4 le Handler a install  ,la structure systeme d'exception
;	adrEXCEPT:DWORD		;ERR_0 la structure err suivante prise dans FS:0     
;			limit la phrase a MAX_PATH
	;macros spcifiques aux exceptions 
	;utilise aussi literal macro inlus dans les macros de masm32  
	EXCEPT MACRO NomProc:REQ,parameters:VARARG
		LOCAL Local_Etiquette
		LOCAL localinvoke
		;rajouter des push ii pour augmenter le nombre de renseignements		
		xor eax,eax	;retour	
		push eax								;pointeur +24
		push EBP     ;sauvegarde ebp  					;pointeur +20
		lea eax,localinvoke
		push eax								;pointeur +16 la pile
		
		mov eax,ADRESSE NomProc						;pointeur +12
					;la phrase identifiant l'erreur
		push eax        	;
		lea eax,Local_Etiquette
		push eax								;pointeur +8
		lea eax,HANDLER	;la nouvelle routine d'exceptions
		push eax								;pointeur +4
		assume FS:NOTHING
		push FS:[0]       	;conserve l'ancien pointeur sur ERR      ;pointeur +0
		mov FS:[0],esp      	;remplacer l'ancien pointeur sur ERR par le nouveau,--
		localinvoke:		;---------------ce qui du meme coup sauvegarde esp
		invoke parameters	;rajouter la ligne tel que
		mov [esp+24],eax	;tout s'est bien passer,prserve la valeur de retour
		Local_Etiquette:		
		mov eax,[esp+24]	;prend la valeur de retour ,modifi en cas d'exceptions
		pop FS:[0]          	;retablir l'ancien err quand la zone protge est termine
		add esp,24          	;6 dword en pile effacer
	ENDM
	
	ADRESSE MACRO bidule:REQ
		EXITM <offset ExceptCreateData (bidule)>
	ENDM

	TESTPILE MACRO taille:REQ	;permet un test pour viter que ce soit	
		Push esi		;le systeme qui soit coinc au moment
		push eax		;de la cration d'un proc en pile
		mov esi,esp		;ne passer que les besoins du proc en pile
		sub esi,taille
		sub esi,4096         ;une page pour le systeme,le systeme a aussi besoin de pile
		xor eax,eax
		mov byte ptr [esi],al
		pop eax
		pop esi
	ENDM


FlagRegistre RECORD rien:13,AC:1,VM:1,RF:1,NUL1:1,NF:1,IO:1,PL:1,OF:1,_DF:1,_IF:1,\
				TF:1,SF:1,ZF:1,NUL2:1,AF:1,NUL3:1,PF:1,un:1,CF:1

	SRCCODEINFO struct
      		SizeOfStruct 	dd	 ?		;set to sizeof(SRCCODEINFO)
       	Key 		dd 	?           	; not used
     		ModBase      QWORD 	?		; base address of module this applies to
        	Obj		DB MAX_PATH + 1 dup (?)     		; the object file within the module
        	FileName	DB MAX_PATH + 1 dup (?) 	; full filename
       	LineNumber	DD  	?	;line number in file
    		Address	QWORD	?    	;first instruction of line
	SRCCODEINFO ends
	SOURCEFILE struct
    		ModBase  QWORD ?;                // base address of loaded module
              FileName  dd ? ;               //pointeur vers full filename of source
	SOURCEFILE ends


;------------------------------------------------------------------------------------------
;-------------------------- fin des declarations d'exceptions -----------------------------
;-----------------------------Dclariations pour librairie dynamique ---------------------	

	PDbgHelpCreateUserDump TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FDbgHelpCreateUserDump TYPEDEF PTR PDbgHelpCreateUserDump
	DbgHelpCreateUserDump TEXTEQU <FDbgHelpCreateUserDump ptr ADbgHelpCreateUserDump>

	PEnumDirTree TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FEnumDirTree TYPEDEF PTR PEnumDirTree
	EnumDirTree TEXTEQU <FEnumDirTree ptr AEnumDirTree>

	PEnumerateLoadedModules TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FEnumerateLoadedModules TYPEDEF PTR PEnumerateLoadedModules
	EnumerateLoadedModules TEXTEQU <FEnumerateLoadedModules ptr AEnumerateLoadedModules>

	PEnumerateLoadedModules64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FEnumerateLoadedModules64 TYPEDEF PTR PEnumerateLoadedModules64
	EnumerateLoadedModules64 TEXTEQU <FEnumerateLoadedModules64 ptr AEnumerateLoadedModules64>

	PEnumerateLoadedModulesW64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FEnumerateLoadedModulesW64 TYPEDEF PTR PEnumerateLoadedModulesW64
	EnumerateLoadedModulesW64 TEXTEQU <FEnumerateLoadedModulesW64 ptr AEnumerateLoadedModulesW64>

	PFindDebugInfoFile TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FFindDebugInfoFile TYPEDEF PTR PFindDebugInfoFile
	FindDebugInfoFile TEXTEQU <FFindDebugInfoFile ptr AFindDebugInfoFile>

	PFindDebugInfoFileEx TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FFindDebugInfoFileEx TYPEDEF PTR PFindDebugInfoFileEx
	FindDebugInfoFileEx TEXTEQU <FFindDebugInfoFileEx ptr AFindDebugInfoFileEx>

	PFindExecutableImage TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FFindExecutableImage TYPEDEF PTR PFindExecutableImage
	FindExecutableImage TEXTEQU <FFindExecutableImage ptr AFindExecutableImage>

	PFindExecutableImageEx TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FFindExecutableImageEx TYPEDEF PTR PFindExecutableImageEx
	FindExecutableImageEx TEXTEQU <FFindExecutableImageEx ptr AFindExecutableImageEx>

	PFindFileInPath TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FFindFileInPath TYPEDEF PTR PFindFileInPath
	FindFileInPath TEXTEQU <FFindFileInPath ptr AFindFileInPath>

	PFindFileInSearchPath TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FFindFileInSearchPath TYPEDEF PTR PFindFileInSearchPath
	FindFileInSearchPath TEXTEQU <FFindFileInSearchPath ptr AFindFileInSearchPath>

	PGetTimestampForLoadedLibrary TYPEDEF PROTO :DWORD
	FGetTimestampForLoadedLibrary TYPEDEF PTR PGetTimestampForLoadedLibrary
	GetTimestampForLoadedLibrary TEXTEQU <FGetTimestampForLoadedLibrary ptr AGetTimestampForLoadedLibrary>

	PImageDirectoryEntryToData TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FImageDirectoryEntryToData TYPEDEF PTR PImageDirectoryEntryToData
	ImageDirectoryEntryToData TEXTEQU <FImageDirectoryEntryToData ptr AImageDirectoryEntryToData>

	PImageDirectoryEntryToDataEx TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FImageDirectoryEntryToDataEx TYPEDEF PTR PImageDirectoryEntryToDataEx
	ImageDirectoryEntryToDataEx TEXTEQU <FImageDirectoryEntryToDataEx ptr AImageDirectoryEntryToDataEx>

	PImageNtHeader TYPEDEF PROTO :DWORD
	FImageNtHeader TYPEDEF PTR PImageNtHeader
	ImageNtHeader TEXTEQU <FImageNtHeader ptr AImageNtHeader>

	PImageRvaToSection TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FImageRvaToSection TYPEDEF PTR PImageRvaToSection
	ImageRvaToSection TEXTEQU <FImageRvaToSection ptr AImageRvaToSection>

	PImageRvaToVa TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FImageRvaToVa TYPEDEF PTR PImageRvaToVa
	ImageRvaToVa TEXTEQU <FImageRvaToVa ptr AImageRvaToVa>

	PImagehlpApiVersionEx TYPEDEF PROTO :DWORD
	FImagehlpApiVersionEx TYPEDEF PTR PImagehlpApiVersionEx
	ImagehlpApiVersionEx TEXTEQU <FImagehlpApiVersionEx ptr AImagehlpApiVersionEx>

	PMakeSureDirectoryPathExists TYPEDEF PROTO :DWORD
	FMakeSureDirectoryPathExists TYPEDEF PTR PMakeSureDirectoryPathExists
	MakeSureDirectoryPathExists TEXTEQU <FMakeSureDirectoryPathExists ptr AMakeSureDirectoryPathExists>

	PMapDebugInformation TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FMapDebugInformation TYPEDEF PTR PMapDebugInformation
	MapDebugInformation TEXTEQU <FMapDebugInformation ptr AMapDebugInformation>

	PMiniDumpReadDumpStream TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FMiniDumpReadDumpStream TYPEDEF PTR PMiniDumpReadDumpStream
	MiniDumpReadDumpStream TEXTEQU <FMiniDumpReadDumpStream ptr AMiniDumpReadDumpStream>

	PMiniDumpWriteDump TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FMiniDumpWriteDump TYPEDEF PTR PMiniDumpWriteDump
	MiniDumpWriteDump TEXTEQU <FMiniDumpWriteDump ptr AMiniDumpWriteDump>

	PSearchTreeForFile TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSearchTreeForFile TYPEDEF PTR PSearchTreeForFile
	SearchTreeForFile TEXTEQU <FSearchTreeForFile ptr ASearchTreeForFile>

	PStackWalk TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FStackWalk TYPEDEF PTR PStackWalk
	StackWalk TEXTEQU <FStackWalk ptr AStackWalk>

	PStackWalk64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FStackWalk64 TYPEDEF PTR PStackWalk64
	StackWalk64 TEXTEQU <FStackWalk64 ptr AStackWalk64>

	PSymAddSymbol TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymAddSymbol TYPEDEF PTR PSymAddSymbol
	SymAddSymbol TEXTEQU <FSymAddSymbol ptr ASymAddSymbol>

	PSymCleanup TYPEDEF PROTO :DWORD
	FSymCleanup TYPEDEF PTR PSymCleanup
	SymCleanup TEXTEQU <FSymCleanup ptr ASymCleanup>

	PSymDeleteSymbol TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymDeleteSymbol TYPEDEF PTR PSymDeleteSymbol
	SymDeleteSymbol TEXTEQU <FSymDeleteSymbol ptr ASymDeleteSymbol>

	PSymEnumLines TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumLines TYPEDEF PTR PSymEnumLines
	SymEnumLines TEXTEQU <FSymEnumLines ptr ASymEnumLines>

	PSymEnumSourceFiles TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumSourceFiles TYPEDEF PTR PSymEnumSourceFiles
	SymEnumSourceFiles TEXTEQU <FSymEnumSourceFiles ptr ASymEnumSourceFiles>

	PSymEnumSourceLines TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumSourceLines TYPEDEF PTR PSymEnumSourceLines
	SymEnumSourceLines TEXTEQU <FSymEnumSourceLines ptr ASymEnumSourceLines>

	PSymEnumSym TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumSym TYPEDEF PTR PSymEnumSym
	SymEnumSym TEXTEQU <FSymEnumSym ptr ASymEnumSym>

	PSymEnumSymbols TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumSymbols TYPEDEF PTR PSymEnumSymbols
	SymEnumSymbols TEXTEQU <FSymEnumSymbols ptr ASymEnumSymbols>

	PSymEnumSymbolsForAddr TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumSymbolsForAddr TYPEDEF PTR PSymEnumSymbolsForAddr
	SymEnumSymbolsForAddr TEXTEQU <FSymEnumSymbolsForAddr ptr ASymEnumSymbolsForAddr>

	PSymEnumTypes TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumTypes TYPEDEF PTR PSymEnumTypes
	SymEnumTypes TEXTEQU <FSymEnumTypes ptr ASymEnumTypes>

	PSymEnumerateModules TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymEnumerateModules TYPEDEF PTR PSymEnumerateModules
	SymEnumerateModules TEXTEQU <FSymEnumerateModules ptr ASymEnumerateModules>

	PSymEnumerateModules64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymEnumerateModules64 TYPEDEF PTR PSymEnumerateModules64
	SymEnumerateModules64 TEXTEQU <FSymEnumerateModules64 ptr ASymEnumerateModules64>

	PSymEnumerateModulesW64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymEnumerateModulesW64 TYPEDEF PTR PSymEnumerateModulesW64
	SymEnumerateModulesW64 TEXTEQU <FSymEnumerateModulesW64 ptr ASymEnumerateModulesW64>

	PSymEnumerateSymbols TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumerateSymbols TYPEDEF PTR PSymEnumerateSymbols
	SymEnumerateSymbols TEXTEQU <FSymEnumerateSymbols ptr ASymEnumerateSymbols>

	PSymEnumerateSymbols64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumerateSymbols64 TYPEDEF PTR PSymEnumerateSymbols64
	SymEnumerateSymbols64 TEXTEQU <FSymEnumerateSymbols64 ptr ASymEnumerateSymbols64>

	PSymEnumerateSymbolsW64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymEnumerateSymbolsW64 TYPEDEF PTR PSymEnumerateSymbolsW64
	SymEnumerateSymbolsW64 TEXTEQU <FSymEnumerateSymbolsW64 ptr ASymEnumerateSymbolsW64>

	PSymFindFileInPath TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymFindFileInPath TYPEDEF PTR PSymFindFileInPath
	SymFindFileInPath TEXTEQU <FSymFindFileInPath ptr ASymFindFileInPath>

	PSymFromAddr TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymFromAddr TYPEDEF PTR PSymFromAddr
	SymFromAddr TEXTEQU <FSymFromAddr ptr ASymFromAddr>

	PSymFromIndex TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymFromIndex TYPEDEF PTR PSymFromIndex
	SymFromIndex TEXTEQU <FSymFromIndex ptr ASymFromIndex>

	PSymFromName TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymFromName TYPEDEF PTR PSymFromName
	SymFromName TEXTEQU <FSymFromName ptr ASymFromName>

	PSymFromToken TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymFromToken TYPEDEF PTR PSymFromToken
	SymFromToken TEXTEQU <FSymFromToken ptr ASymFromToken>

	PSymFunctionTableAccess TYPEDEF PROTO :DWORD,:DWORD
	FSymFunctionTableAccess TYPEDEF PTR PSymFunctionTableAccess
	SymFunctionTableAccess TEXTEQU <FSymFunctionTableAccess ptr ASymFunctionTableAccess>

	PSymFunctionTableAccess64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymFunctionTableAccess64 TYPEDEF PTR PSymFunctionTableAccess64
	SymFunctionTableAccess64 TEXTEQU <FSymFunctionTableAccess64 ptr ASymFunctionTableAccess64>

	PSymGetFileLineOffsets64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetFileLineOffsets64 TYPEDEF PTR PSymGetFileLineOffsets64
	SymGetFileLineOffsets64 TEXTEQU <FSymGetFileLineOffsets64 ptr ASymGetFileLineOffsets64>

	PSymGetHomeDirectory TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymGetHomeDirectory TYPEDEF PTR PSymGetHomeDirectory
	SymGetHomeDirectory TEXTEQU <FSymGetHomeDirectory ptr ASymGetHomeDirectory>

	PSymGetLineFromAddr TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymGetLineFromAddr TYPEDEF PTR PSymGetLineFromAddr
	SymGetLineFromAddr TEXTEQU <FSymGetLineFromAddr ptr ASymGetLineFromAddr>

	PSymGetLineFromAddr64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetLineFromAddr64 TYPEDEF PTR PSymGetLineFromAddr64
	SymGetLineFromAddr64 TEXTEQU <FSymGetLineFromAddr64 ptr ASymGetLineFromAddr64>

	PSymGetLineFromAddrW64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetLineFromAddrW64 TYPEDEF PTR PSymGetLineFromAddrW64
	SymGetLineFromAddrW64 TEXTEQU <FSymGetLineFromAddrW64 ptr ASymGetLineFromAddrW64>

	PSymGetLineFromName TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetLineFromName TYPEDEF PTR PSymGetLineFromName
	SymGetLineFromName TEXTEQU <FSymGetLineFromName ptr ASymGetLineFromName>

	PSymGetLineFromName64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetLineFromName64 TYPEDEF PTR PSymGetLineFromName64
	SymGetLineFromName64 TEXTEQU <FSymGetLineFromName64 ptr ASymGetLineFromName64>

	PSymGetLineFromNameW64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetLineFromNameW64 TYPEDEF PTR PSymGetLineFromNameW64
	SymGetLineFromNameW64 TEXTEQU <FSymGetLineFromNameW64 ptr ASymGetLineFromNameW64>

	PSymGetLineNext TYPEDEF PROTO :DWORD,:DWORD
	FSymGetLineNext TYPEDEF PTR PSymGetLineNext
	SymGetLineNext TEXTEQU <FSymGetLineNext ptr ASymGetLineNext>

	PSymGetLineNext64 TYPEDEF PROTO :DWORD,:DWORD
	FSymGetLineNext64 TYPEDEF PTR PSymGetLineNext64
	SymGetLineNext64 TEXTEQU <FSymGetLineNext64 ptr ASymGetLineNext64>

	PSymGetLineNextW64 TYPEDEF PROTO :DWORD,:DWORD
	FSymGetLineNextW64 TYPEDEF PTR PSymGetLineNextW64
	SymGetLineNextW64 TEXTEQU <FSymGetLineNextW64 ptr ASymGetLineNextW64>

	PSymGetLinePrev TYPEDEF PROTO :DWORD,:DWORD
	FSymGetLinePrev TYPEDEF PTR PSymGetLinePrev
	SymGetLinePrev TEXTEQU <FSymGetLinePrev ptr ASymGetLinePrev>

	PSymGetLinePrev64 TYPEDEF PROTO :DWORD,:DWORD
	FSymGetLinePrev64 TYPEDEF PTR PSymGetLinePrev64
	SymGetLinePrev64 TEXTEQU <FSymGetLinePrev64 ptr ASymGetLinePrev64>

	PSymGetLinePrevW64 TYPEDEF PROTO :DWORD,:DWORD
	FSymGetLinePrevW64 TYPEDEF PTR PSymGetLinePrevW64
	SymGetLinePrevW64 TEXTEQU <FSymGetLinePrevW64 ptr ASymGetLinePrevW64>

	PSymGetModuleBase TYPEDEF PROTO :DWORD,:DWORD
	FSymGetModuleBase TYPEDEF PTR PSymGetModuleBase
	SymGetModuleBase TEXTEQU <FSymGetModuleBase ptr ASymGetModuleBase>

	PSymGetModuleBase64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymGetModuleBase64 TYPEDEF PTR PSymGetModuleBase64
	SymGetModuleBase64 TEXTEQU <FSymGetModuleBase64 ptr ASymGetModuleBase64>

	PSymGetModuleInfo TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymGetModuleInfo TYPEDEF PTR PSymGetModuleInfo
	SymGetModuleInfo TEXTEQU <FSymGetModuleInfo ptr ASymGetModuleInfo>

	PSymGetModuleInfo64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymGetModuleInfo64 TYPEDEF PTR PSymGetModuleInfo64
	SymGetModuleInfo64 TEXTEQU <FSymGetModuleInfo64 ptr ASymGetModuleInfo64>

	PSymGetModuleInfoW64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymGetModuleInfoW64 TYPEDEF PTR PSymGetModuleInfoW64
	SymGetModuleInfoW64 TEXTEQU <FSymGetModuleInfoW64 ptr ASymGetModuleInfoW64>

	PSymGetScope TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetScope TYPEDEF PTR PSymGetScope
	SymGetScope TEXTEQU <FSymGetScope ptr ASymGetScope>

	PSymGetSearchPath TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymGetSearchPath TYPEDEF PTR PSymGetSearchPath
	SymGetSearchPath TEXTEQU <FSymGetSearchPath ptr ASymGetSearchPath>

	PSymGetSourceFile TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetSourceFile TYPEDEF PTR PSymGetSourceFile
	SymGetSourceFile TEXTEQU <FSymGetSourceFile ptr ASymGetSourceFile>

	PSymGetSourceFileFromToken TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetSourceFileFromToken TYPEDEF PTR PSymGetSourceFileFromToken
	SymGetSourceFileFromToken TEXTEQU <FSymGetSourceFileFromToken ptr ASymGetSourceFileFromToken>

	PSymGetSourceFileToken TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetSourceFileToken TYPEDEF PTR PSymGetSourceFileToken
	SymGetSourceFileToken TEXTEQU <FSymGetSourceFileToken ptr ASymGetSourceFileToken>

	PSymGetSourceVarFromToken TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetSourceVarFromToken TYPEDEF PTR PSymGetSourceVarFromToken
	SymGetSourceVarFromToken TEXTEQU <FSymGetSourceVarFromToken ptr ASymGetSourceVarFromToken>

	PSymGetSymFromAddr TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymGetSymFromAddr TYPEDEF PTR PSymGetSymFromAddr
	SymGetSymFromAddr TEXTEQU <FSymGetSymFromAddr ptr ASymGetSymFromAddr>

	PSymGetSymFromAddr64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetSymFromAddr64 TYPEDEF PTR PSymGetSymFromAddr64
	SymGetSymFromAddr64 TEXTEQU <FSymGetSymFromAddr64 ptr ASymGetSymFromAddr64>

	PSymGetSymFromName TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymGetSymFromName TYPEDEF PTR PSymGetSymFromName
	SymGetSymFromName TEXTEQU <FSymGetSymFromName ptr ASymGetSymFromName>

	PSymGetSymFromName64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymGetSymFromName64 TYPEDEF PTR PSymGetSymFromName64
	SymGetSymFromName64 TEXTEQU <FSymGetSymFromName64 ptr ASymGetSymFromName64>

	PSymGetSymNext TYPEDEF PROTO :DWORD,:DWORD
	FSymGetSymNext TYPEDEF PTR PSymGetSymNext
	SymGetSymNext TEXTEQU <FSymGetSymNext ptr ASymGetSymNext>

	PSymGetSymNext64 TYPEDEF PROTO :DWORD,:DWORD
	FSymGetSymNext64 TYPEDEF PTR PSymGetSymNext64
	SymGetSymNext64 TEXTEQU <FSymGetSymNext64 ptr ASymGetSymNext64>

	PSymGetSymPrev TYPEDEF PROTO :DWORD,:DWORD
	FSymGetSymPrev TYPEDEF PTR PSymGetSymPrev
	SymGetSymPrev TEXTEQU <FSymGetSymPrev ptr ASymGetSymPrev>

	PSymGetSymPrev64 TYPEDEF PROTO :DWORD,:DWORD
	FSymGetSymPrev64 TYPEDEF PTR PSymGetSymPrev64
	SymGetSymPrev64 TEXTEQU <FSymGetSymPrev64 ptr ASymGetSymPrev64>

	PSymGetSymbolFile TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetSymbolFile TYPEDEF PTR PSymGetSymbolFile
	SymGetSymbolFile TEXTEQU <FSymGetSymbolFile ptr ASymGetSymbolFile>

	PSymGetTypeFromName TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetTypeFromName TYPEDEF PTR PSymGetTypeFromName
	SymGetTypeFromName TEXTEQU <FSymGetTypeFromName ptr ASymGetTypeFromName>

	PSymGetTypeInfo TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymGetTypeInfo TYPEDEF PTR PSymGetTypeInfo
	SymGetTypeInfo TEXTEQU <FSymGetTypeInfo ptr ASymGetTypeInfo>

	PSymGetTypeInfoEx TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymGetTypeInfoEx TYPEDEF PTR PSymGetTypeInfoEx
	SymGetTypeInfoEx TEXTEQU <FSymGetTypeInfoEx ptr ASymGetTypeInfoEx>

	PSymInitialize TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymInitialize TYPEDEF PTR PSymInitialize
	SymInitialize TEXTEQU <FSymInitialize ptr ASymInitialize>

	PSymLoadModule TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymLoadModule TYPEDEF PTR PSymLoadModule
	SymLoadModule TEXTEQU <FSymLoadModule ptr ASymLoadModule>

	PSymLoadModule64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymLoadModule64 TYPEDEF PTR PSymLoadModule64
	SymLoadModule64 TEXTEQU <FSymLoadModule64 ptr ASymLoadModule64>

	PSymLoadModuleEx TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymLoadModuleEx TYPEDEF PTR PSymLoadModuleEx
	SymLoadModuleEx TEXTEQU <FSymLoadModuleEx ptr ASymLoadModuleEx>

	PSymMatchFileName TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymMatchFileName TYPEDEF PTR PSymMatchFileName
	SymMatchFileName TEXTEQU <FSymMatchFileName ptr ASymMatchFileName>

	PSymMatchStringA TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymMatchStringA TYPEDEF PTR PSymMatchStringA
	SymMatchString TEXTEQU <FSymMatchStringA ptr ASymMatchStringA>

	PSymNext TYPEDEF PROTO :DWORD,:DWORD
	FSymNext TYPEDEF PTR PSymNext
	SymNext TEXTEQU <FSymNext ptr ASymNext>

	PSymPrev TYPEDEF PROTO :DWORD,:DWORD
	FSymPrev TYPEDEF PTR PSymPrev
	SymPrev TEXTEQU <FSymPrev ptr ASymPrev>

	PSymRegisterCallback TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymRegisterCallback TYPEDEF PTR PSymRegisterCallback
	SymRegisterCallback TEXTEQU <FSymRegisterCallback ptr ASymRegisterCallback>

	PSymRegisterCallback64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymRegisterCallback64 TYPEDEF PTR PSymRegisterCallback64
	SymRegisterCallback64 TEXTEQU <FSymRegisterCallback64 ptr ASymRegisterCallback64>

	PSymRegisterCallbackW64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymRegisterCallbackW64 TYPEDEF PTR PSymRegisterCallbackW64
	SymRegisterCallbackW64 TEXTEQU <FSymRegisterCallbackW64 ptr ASymRegisterCallbackW64>

	PSymRegisterFunctionEntryCallback TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymRegisterFunctionEntryCallback TYPEDEF PTR PSymRegisterFunctionEntryCallback
	SymRegisterFunctionEntryCallback TEXTEQU <FSymRegisterFunctionEntryCallback ptr ASymRegisterFunctionEntryCallback>

	PSymRegisterFunctionEntryCallback64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymRegisterFunctionEntryCallback64 TYPEDEF PTR PSymRegisterFunctionEntryCallback64
	SymRegisterFunctionEntryCallback64 TEXTEQU <FSymRegisterFunctionEntryCallback64 ptr ASymRegisterFunctionEntryCallback64>

	PSymSearch TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymSearch TYPEDEF PTR PSymSearch
	SymSearch TEXTEQU <FSymSearch ptr ASymSearch>

	PSymSetContext TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymSetContext TYPEDEF PTR PSymSetContext
	SymSetContext TEXTEQU <FSymSetContext ptr ASymSetContext>

	PSymSetHomeDirectory TYPEDEF PROTO :DWORD,:DWORD
	FSymSetHomeDirectory TYPEDEF PTR PSymSetHomeDirectory
	SymSetHomeDirectory TEXTEQU <FSymSetHomeDirectory ptr ASymSetHomeDirectory>

	PSymSetOptions TYPEDEF PROTO :DWORD
	FSymSetOptions TYPEDEF PTR PSymSetOptions
	SymSetOptions TEXTEQU <FSymSetOptions ptr ASymSetOptions>

	PSymSetParentWindow TYPEDEF PROTO :DWORD
	FSymSetParentWindow TYPEDEF PTR PSymSetParentWindow
	SymSetParentWindow TEXTEQU <FSymSetParentWindow ptr ASymSetParentWindow>

	PSymSetSearchPath TYPEDEF PROTO :DWORD,:DWORD
	FSymSetSearchPath TYPEDEF PTR PSymSetSearchPath
	SymSetSearchPath TEXTEQU <FSymSetSearchPath ptr ASymSetSearchPath>

	PSymSrvDeltaName TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymSrvDeltaName TYPEDEF PTR PSymSrvDeltaName
	SymSrvDeltaName TEXTEQU <FSymSrvDeltaName ptr ASymSrvDeltaName>

	PSymSrvGetFileIndexString TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymSrvGetFileIndexString TYPEDEF PTR PSymSrvGetFileIndexString
	SymSrvGetFileIndexString TEXTEQU <FSymSrvGetFileIndexString ptr ASymSrvGetFileIndexString>

	PSymSrvGetFileIndexes TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymSrvGetFileIndexes TYPEDEF PTR PSymSrvGetFileIndexes
	SymSrvGetFileIndexes TEXTEQU <FSymSrvGetFileIndexes ptr ASymSrvGetFileIndexes>

	PSymSrvGetSupplement TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymSrvGetSupplement TYPEDEF PTR PSymSrvGetSupplement
	SymSrvGetSupplement TEXTEQU <FSymSrvGetSupplement ptr ASymSrvGetSupplement>

	PSymSrvIsStore TYPEDEF PROTO :DWORD,:DWORD
	FSymSrvIsStore TYPEDEF PTR PSymSrvIsStore
	SymSrvIsStore TEXTEQU <FSymSrvIsStore ptr ASymSrvIsStore>

	PSymSrvStoreFile TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FSymSrvStoreFile TYPEDEF PTR PSymSrvStoreFile
	SymSrvStoreFile TEXTEQU <FSymSrvStoreFile ptr ASymSrvStoreFile>

	PSymSrvStoreSupplement TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	FSymSrvStoreSupplement TYPEDEF PTR PSymSrvStoreSupplement
	SymSrvStoreSupplement TEXTEQU <FSymSrvStoreSupplement ptr ASymSrvStoreSupplement>

	PSymUnDName TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymUnDName TYPEDEF PTR PSymUnDName
	SymUnDName TEXTEQU <FSymUnDName ptr ASymUnDName>

	PSymUnDName64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymUnDName64 TYPEDEF PTR PSymUnDName64
	SymUnDName64 TEXTEQU <FSymUnDName64 ptr ASymUnDName64>

	PSymUnloadModule TYPEDEF PROTO :DWORD,:DWORD
	FSymUnloadModule TYPEDEF PTR PSymUnloadModule
	SymUnloadModule TEXTEQU <FSymUnloadModule ptr ASymUnloadModule>

	PSymUnloadModule64 TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FSymUnloadModule64 TYPEDEF PTR PSymUnloadModule64
	SymUnloadModule64 TEXTEQU <FSymUnloadModule64 ptr ASymUnloadModule64>

	PUnDecorateSymbolName TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	FUnDecorateSymbolName TYPEDEF PTR PUnDecorateSymbolName
	UnDecorateSymbolName TEXTEQU <FUnDecorateSymbolName ptr AUnDecorateSymbolName>

	PUnmapDebugInformation TYPEDEF PROTO :DWORD
	FUnmapDebugInformation TYPEDEF PTR PUnmapDebugInformation
	UnmapDebugInformation TEXTEQU <FUnmapDebugInformation ptr AUnmapDebugInformation>

	PWinDbgExtensionDllInit TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	FWinDbgExtensionDllInit TYPEDEF PTR PWinDbgExtensionDllInit
	WinDbgExtensionDllInit TEXTEQU <FWinDbgExtensionDllInit ptr AWinDbgExtensionDllInit>

	Pblock TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fblock TYPEDEF PTR Pblock
	block TEXTEQU <Fblock ptr Ablock>

	Pdbghelp TYPEDEF PROTO :DWORD,:DWORD
	Fdbghelp TYPEDEF PTR Pdbghelp
	dbghelp TEXTEQU <Fdbghelp ptr Adbghelp>

	Pfptr TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Ffptr TYPEDEF PTR Pfptr
	fptr TEXTEQU <Ffptr ptr Afptr>

	Phomedir TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fhomedir TYPEDEF PTR Phomedir
	homedir TEXTEQU <Fhomedir ptr Ahomedir>

	Plmi TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Flmi TYPEDEF PTR Plmi
	lmi TEXTEQU <Flmi ptr Almi>

	Plminfo TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Flminfo TYPEDEF PTR Plminfo
	lminfo TEXTEQU <Flminfo ptr Alminfo>

	Pomap TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fomap TYPEDEF PTR Pomap
	omap TEXTEQU <Fomap ptr Aomap>

	Psrcfiles TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fsrcfiles TYPEDEF PTR Psrcfiles
	srcfiles TEXTEQU <Fsrcfiles ptr Asrcfiles>

	Pstack_force_ebp TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fstack_force_ebp TYPEDEF PTR Pstack_force_ebp
	stack_force_ebp TEXTEQU <Fstack_force_ebp ptr Astack_force_ebp>

	Pstackdbg TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fstackdbg TYPEDEF PTR Pstackdbg
	stackdbg TEXTEQU <Fstackdbg ptr Astackdbg>

	Psym TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fsym TYPEDEF PTR Psym
	sym TEXTEQU <Fsym ptr Asym>

	Psymsrv TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fsymsrv TYPEDEF PTR Psymsrv
	symsrv TEXTEQU <Fsymsrv ptr Asymsrv>

	Pvc7fpo TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Fvc7fpo TYPEDEF PTR Pvc7fpo
	vc7fpo TEXTEQU <Fvc7fpo ptr Avc7fpo>
	



;----------------------------------- fin des dclarations dynamiques
   .data	
FindeProgramme   dd 0
DebutdeProgramme dd 0
OubliExcept	    db "            Pas de solution",13,10
		    db "     Probablement un oubli de EXCEPT",13,10,13,10
		    db "EXCEPT (",34,"Texte de localisation",34,"),Winmain,arg1,..",0	
;----------------------------------------------------------------------------------------------------------
;emplacement pour sauvegarder l'enregistrement de l'erreur
;-- pour modifier le comportement du systeme , il faut modifier la structure qu'il nous passe
;------------------------------ data exceptions -------------------------------------------------
		excPresenceSymboles 	dd 0
		excCrashAdresse	DD 0
		excCrashListing	DD 0
		excSymRVApremiereligne dd 0
		excPhraseReponse 	db MAX_PATH dup (0)
		excCodeModule 	dd 0
		excPositionAdresse 	dd 0
		excszbreakpoint  	db MAX_PATH dup (0)
		Excepttraite  	dd 0	;permet d'viter l'enchainement des handlers 
		excFATALMESS 		DB "Le premier appel de HANDLER ",0Dh,0Ah
					DB "la routine de traitement de l'erreur",0Dh,0Ah
					DB "Informer l'utilisateur , se brancher a l'adresse de retour ",0Dh,0Ah
					DB "Mais en premier verifie la faisabilit (continuable) ",0
		except 		db "Except1",0
		excquestion 		DB "Une exception(erreur) s",39,"est produite ",0Dh,0Ah
					DB 'Voulez vous passer la zone de code erron',0Dh,0Ah
					DB "Pour pouvoir continuer le programme",0
		excunwinding 		DB "Deuxieme appel de HANDLER par le systeme (unwind)",0
		excpastrouve 		DB "Message d exception non trouve",0
		excpointeur		DD 0
		HExceptInstance	DD 0
		excazer 		DB 256 DUP(0)
		excsauvereg 		dd 10 dup (0)
		excretourmeser 	DB 256 DUP(0)
		szEXCEPTEDIT1 	DB 11 DUP(0)
		excTITRE000		DB "mesexcept",0
		oldHandler    	dd 0
		Mesexcept 		DB "EXCEPTION_ACCESS_VIOLATION",0
					DD EXCEPTION_ACCESS_VIOLATION,0
					DB "EXCEPTION_DATATYPE_MISALIGNMENT",0
					DD EXCEPTION_DATATYPE_MISALIGNMENT,0
					DB "EXCEPTION_BREAKPOINT",0	
					DD EXCEPTION_BREAKPOINT,0	
					DB "EXCEPTION_SINGLE_STEP",0		
					DD EXCEPTION_SINGLE_STEP,0
					DB "EXCEPTION_ARRAY_BOUNDS_EXCEEDED",0
					DD EXCEPTION_ARRAY_BOUNDS_EXCEEDED,0
					DB "EXCEPTION_FLT_DENORMAL_OPERAND	",0	
					DD EXCEPTION_FLT_DENORMAL_OPERAND,0
					DB "EXCEPTION_FLT_DIVIDE_BY_ZERO",0
					DD EXCEPTION_FLT_DIVIDE_BY_ZERO,0
					DB "EXCEPTION_FLT_INEXACT_RESULT",0	
					DD EXCEPTION_FLT_INEXACT_RESULT,0
					DB "EXCEPTION_FLT_INVALID_OPERATION",0	
					DD EXCEPTION_FLT_INVALID_OPERATION,0
					DB "EXCEPTION_FLT_OVERFLOW",0	
					DD EXCEPTION_FLT_OVERFLOW,0
					DB "EXCEPTION_FLT_STACK_CHECK",0	
					DD EXCEPTION_FLT_STACK_CHECK,0
					DB "EXCEPTION_FLT_UNDERFLOW",0	
					DD EXCEPTION_FLT_UNDERFLOW,0
					DB "EXCEPTION_INT_DIVIDE_BY_ZERO",0	
					DD EXCEPTION_INT_DIVIDE_BY_ZERO,0
					DB "EXCEPTION_INT_OVERFLOW",0	
					DD EXCEPTION_INT_OVERFLOW,0
					DB "EXCEPTION_PRIV_INSTRUCTION",0		
					DD EXCEPTION_PRIV_INSTRUCTION,0
					DB "EXCEPTION_IN_PAGE_ERROR",0
					DD EXCEPTION_IN_PAGE_ERROR,0
					DB "EXCEPTION_ILLEGAL_INSTRUCTION",0 
					DD EXCEPTION_ILLEGAL_INSTRUCTION,0 		
					DB "EXCEPTION_NONCONTINUABLE_EXCEPTION",0
					DD EXCEPTION_NONCONTINUABLE_EXCEPTION,0
					DB "EXCEPTION_STACK_OVERFLOW",0
					DD EXCEPTION_STACK_OVERFLOW,0
					DB "EXCEPTION_INVALID_DISPOSITION",0
					DD EXCEPTION_INVALID_DISPOSITION,0
					DB "EXCEPTION_GUARD_PAGE",0
					DD EXCEPTION_GUARD_PAGE,0,0
				
flag18 db "AC=",0
flag17 db " : VM=",0
flag16 db " : RF=",0
flag15 db " : __ ",0		;NUL1
flag14 db " : NF=",0
flag13 db " : IO=",0
flag12 db " : PL=",0
flag11 db " : OF=",0
flag10 db " : DF=",0
;------------------------etiquette suivante
flag9 db "IF=",0
flag8 db " : TF=",0
flag7 db " : SF=",0
flag6 db " : ZF=",0
flag5 db " : __ ",0		;NUL2
flag4 db " : AF=",0
flag3 db " : __ ",0		;NUL3
flag2 db " : PF=",0
flag1 db " : _1 ",0		;un
flag0 db " : CF=",0


;**********fin des data exceptions ******************** 
;--------------------------------------------------------------------------------------
;-------------------- pour les symboles ---------------------------------------------
	HprocessSym dd 0
	HthreadSym dd 0
	excTemoindeRetour dd 0
	CPTpile dd 0
	LoadedImage LOADED_IMAGE <>
	excdecalage dd 0
	excSymRVAcrash dd 0
	exctampon        db 500 dup (0)
	excRVA		    dd 0
	excSymbolsPath	db MAX_PATH +1 dup  (0)		;repertoire ou dpose les fichiers
	excdwModuleBase dd 0	
	excModuleImagehelp IMAGEHLP_MODULE <>
	excsLigne IMAGEHLP_LINE <>
	excchercheligne SRCCODEINFO <>
	excMemoSRCCODE SRCCODEINFO <>
	;----------- Bug windows ,le nom de fichier dpasse la structure (1 byte pour le nom)	
	excsymbole IMAGEHLP_SYMBOL <>
	excrepsymb db MAX_PATH +1 dup (0)
	;------------------------ ne pas sparer les lignes------------------------------
	excdeplacement dd 0
	excPremiereLigne dd 0
	excNomDebugger   db MAX_PATH +1 dup (0)
	excPremierSource db MAX_PATH +1 dup (0)	
	excespace db "  ",0
	excunespace db " ",0
	excCPT dd 0
	excatest dd 0
	excPosnomCourt dd 0
	excMesretour db 13,10,"Recalcul a partir de l'adresse de retour",13,10,"NB de boucles :",0
	excFormatAfficheligne  		db "SizeOfStruct: %lx ",0dh,0Ah
						db "Key: %lx",0Dh,0Ah
						db "ModBase    :%lx",0Dh,0Ah
						db "Obj        :%hs",0Dh,0Ah
						db "FileName   : %hs",0Dh,0Ah
						db "LineNumber : %lu",0Dh,0Ah
						db "Address    : %lx",0
	excFormatAffichemodule  		db "ModuleName : %hs",0dh,0Ah
						db "BaseOfDll   : %lx",0Dh,0Ah
						db "UserContext :%lx",0
	excformatIMAGEHLP_LINE		db "SizeOfStruct: %lx ",0dh,0Ah
						db "Key: %lx",0Dh,0Ah
						db "LineNumber : %lu",0Dh,0Ah
						db "FileName   : %hs",0Dh,0Ah
						db "Address    : %lx",0
				
	;-------------------------------------------------------------------------------------
	;stack
	excCopieContextStack CONTEXT <>
	excfpo_data FPO_DATA <>
	
	excFormatSTACKFRAME 			DB "AddrPC     ADDRESS <>: %lx",0Dh,0Ah
						DB "AddrReturn ADDRESS <>: %lx ",0Dh,0Ah
						DB "AddrFrame  ADDRESS <>: %lx ",0Dh,0Ah
						DB "AddrStack  ADDRESS <>: %lx ",0Dh,0Ah
						DB "FuncTableEntry       : %lx ",0Dh,0Ah
						DB "Params0              : %lx ",0Dh,0Ah
						DB "	 	    Params1: %lx ",0Dh,0Ah
						DB "	 	    Params2: %lx ",0Dh,0Ah
						DB "	           Params3: %lx ",0Dh,0Ah
						DB "Far1		    : %lx ",0Dh,0Ah
						DB "Virtual		    : %lx ",0Dh,0Ah
						DB "Reserved		    : %lx  ",0Dh,0Ah
						DB "KdHelp     KDHELP    : %lx ",0
	excHsortie dd 0
	excminidumpContext dd 0
	excminidumppExceptionRecord dd 0
	excCheminmodule db MAX_PATH + 1 dup(0)
	excCheminDump db MAX_PATH + 1 dup(0)
	excExtDmp db "DMP",0
	
	; data dll
	
	Hlibrairie dd 0
	ADbgHelpCreateUserDump dd 0
	AEnumDirTree dd 0
	AEnumerateLoadedModules dd 0
	AEnumerateLoadedModules64 dd 0
	AEnumerateLoadedModulesW64 dd 0
	AFindDebugInfoFile dd 0
	AFindDebugInfoFileEx dd 0
	AFindExecutableImage dd 0
	AFindExecutableImageEx dd 0
	AFindFileInPath dd 0
	AFindFileInSearchPath dd 0
	AGetTimestampForLoadedLibrary dd 0
	AImageDirectoryEntryToData dd 0
	AImageDirectoryEntryToDataEx dd 0
	AImageNtHeader dd 0
	AImageRvaToSection dd 0
	AImageRvaToVa dd 0
	AImagehlpApiVersionEx dd 0
	AMakeSureDirectoryPathExists dd 0
	AMapDebugInformation dd 0
	AMiniDumpReadDumpStream dd 0
	AMiniDumpWriteDump dd 0
	ASearchTreeForFile dd 0
	AStackWalk dd 0
	AStackWalk64 dd 0
	ASymAddSymbol dd 0
	ASymCleanup dd 0
	ASymDeleteSymbol dd 0
	ASymEnumLines dd 0
	ASymEnumSourceFiles dd 0
	ASymEnumSourceLines dd 0
	ASymEnumSym dd 0
	ASymEnumSymbols dd 0
	ASymEnumSymbolsForAddr dd 0
	ASymEnumTypes dd 0
	ASymEnumerateModules dd 0
	ASymEnumerateModules64 dd 0
	ASymEnumerateModulesW64 dd 0
	ASymEnumerateSymbols dd 0
	ASymEnumerateSymbols64 dd 0
	ASymEnumerateSymbolsW64 dd 0
	ASymFindFileInPath dd 0
	ASymFromAddr dd 0
	ASymFromIndex dd 0
	ASymFromName dd 0
	ASymFromToken dd 0
	ASymFunctionTableAccess dd 0
	ASymFunctionTableAccess64 dd 0
	ASymGetFileLineOffsets64 dd 0
	ASymGetHomeDirectory dd 0
	ASymGetLineFromAddr dd 0
	ASymGetLineFromAddr64 dd 0
	ASymGetLineFromAddrW64 dd 0
	ASymGetLineFromName dd 0
	ASymGetLineFromName64 dd 0
	ASymGetLineFromNameW64 dd 0
	ASymGetLineNext dd 0
	ASymGetLineNext64 dd 0
	ASymGetLineNextW64 dd 0
	ASymGetLinePrev dd 0
	ASymGetLinePrev64 dd 0
	ASymGetLinePrevW64 dd 0
	ASymGetModuleBase dd 0
	ASymGetModuleBase64 dd 0
	ASymGetModuleInfo dd 0
	ASymGetModuleInfo64 dd 0
	ASymGetModuleInfoW64 dd 0
	ASymGetScope dd 0
	ASymGetSearchPath dd 0
	ASymGetSourceFile dd 0
	ASymGetSourceFileFromToken dd 0
	ASymGetSourceFileToken dd 0
	ASymGetSourceVarFromToken dd 0
	ASymGetSymFromAddr dd 0
	ASymGetSymFromAddr64 dd 0
	ASymGetSymFromName dd 0
	ASymGetSymFromName64 dd 0
	ASymGetSymNext dd 0
	ASymGetSymNext64 dd 0
	ASymGetSymPrev dd 0
	ASymGetSymPrev64 dd 0
	ASymGetSymbolFile dd 0
	ASymGetTypeFromName dd 0
	ASymGetTypeInfo dd 0
	ASymGetTypeInfoEx dd 0
	ASymInitialize dd 0
	ASymLoadModule dd 0
	ASymLoadModule64 dd 0
	ASymLoadModuleEx dd 0
	ASymMatchFileName dd 0
	ASymMatchStringA dd 0
	ASymNext dd 0
	ASymPrev dd 0
	ASymRegisterCallback dd 0
	ASymRegisterCallback64 dd 0
	ASymRegisterCallbackW64 dd 0
	ASymRegisterFunctionEntryCallback dd 0
	ASymRegisterFunctionEntryCallback64 dd 0
	ASymSearch dd 0
	ASymSetContext dd 0
	ASymSetHomeDirectory dd 0
	ASymSetOptions dd 0
	ASymSetParentWindow dd 0
	ASymSetSearchPath dd 0
	ASymSrvDeltaName dd 0
	ASymSrvGetFileIndexString dd 0
	ASymSrvGetFileIndexes dd 0
	ASymSrvGetSupplement dd 0
	ASymSrvIsStore dd 0
	ASymSrvStoreFile dd 0
	ASymSrvStoreSupplement dd 0
	ASymUnDName dd 0
	ASymUnDName64 dd 0
	ASymUnloadModule dd 0
	ASymUnloadModule64 dd 0
	AUnDecorateSymbolName dd 0
	AUnmapDebugInformation dd 0
	AWinDbgExtensionDllInit dd 0
	Ablock dd 0
	Adbghelp dd 0
	Afptr dd 0
	Ahomedir dd 0
	Almi dd 0
	Alminfo dd 0
	Aomap dd 0
	Asrcfiles dd 0
	Astack_force_ebp dd 0
	Astackdbg dd 0
	Asym dd 0
	Asymsrv dd 0
	Avc7fpo dd 0
	;------------------------ fin data dll -------------------------
	;data pour DDE
	NomServeur db "EditMasm Version 2",0
	MarqueurDDE db "except:",0
	AtomRubrique db (MAX_PATH +1) dup (0)
	;-------- les deux donnes a envoyer a editmasm par dde
	PlanteLigne	dd 0		;conserver le numro de ligne	
	;excchercheligne.FileName
	MesEditmasm db "WM_EDITMASM",0
	
	
    .code
;------------------------------------------------------------------------------------
;------------------------ le code n'est plus composer que de proc -----------------
;----------------------------------------------------------------------------------

; #########################################################################

;ci dessous la routine appel par le systeme en cas d'erreur
;si l'interuption est continuable , l'utilisateur peut choisir de traiter ou non l'interruption
;en cas de traitement voulu , branchement a FINAL_HANDLER
;la structure du proc n'est pas dcrite dans le SDK
;le tableau de renseignements dans la pile se prsente ainsi,noms indicatifs
;
;	retour:DWORD 			;prserve la valeur de retour du proc si russite
;	Basepointeur:DWORD		;la valeur originale de EBP
;	adrInvoke:DWORD		;adresse de invoke
;	NomGenerique:DWORD		;le nom gnrique permettant de localiser l'erreur dans le source
;	adrAbandonProc:DWORD		;l'adresse de retour si on choisit de passer l'execution du proc
;	adrHANDLER:DWORD		;ERR_+4 le Handler a install  ,la structure systeme d'exception
;	adrEXCEPT:DWORD		;ERR_0 la structure err suivante prise dans FS:0

HANDLER PROC uses esi edi ebx Pexcept:DWORD,Perr:DWORD,Pcontext:DWORD,Pdispatch:DWORD
		LOCAL retour:DWORD
		LOCAL PossibleRetour:DWORD
		

	mov retour,EXCEPTION_EXECUTE_HANDLER
	;microsoft est terriblement cachotier sur les exceptions handling
	;parcourir msdn m'a seulement appris que le c++ utilise try,except,throw et ...
	;aucune documentation microsoft ne mentionne l'architecture de Handler telle
	;que vous l'avez l.La structure MASM32 que vous avez l est le rsultat de repiquage
	;franco anglais dans des sources crits en divers assembleurs
	;la preuve de son criture correcte est qu'il fonctionne parfaitement
	;Quatre types d'exceptions existent,comme je n'ai aucune information
	;sur la quatrieme,elle est dans windows.inc,j'ai mis un retour par dfaut	
	
	.if Excepttraite == 1
		mov retour,EXCEPTION_EXECUTE_HANDLER               ;eax=1 aller au handler suivant
					;permet d'aller a FINAL_HANDLER sans retraiter N fois l'exception
					;N tant le nombre de EXCEPT insrer dans le source
		jmp FindeHANDLER
	.else
		mov Excepttraite,1
	.endif
	
	MOV EBX,Pexcept   		;EXCEPTION_RECORD 
	MOV EAX,(EXCEPTION_RECORD ptr [EBX]).ExceptionFlags         	;get flag sent by the system
	;********* le systeme interdit t il le traitement de l'erreur ? ***************************
	.if eax == EXCEPTION_CONTINUABLE
		;trait en premier le breakpoint,pas de messagebox
		MOV EBX,Pexcept  ;EXCEPTION_RECORD       				;get exception record in ebx
		mov edx,(EXCEPTION_RECORD ptr [EBX]).ExceptionCode
		.if edx == EXCEPTION_BREAKPOINT
			;avance eip de l'instruction int 3 cc
			mov ebx,Pcontext
			mov edx,(CONTEXT ptr [EBX]).regEip
			mov excCrashAdresse,edx					
			inc edx  						;int 3 cod un octet cc
			mov (CONTEXT ptr [EBX]).regEip,edx			;eip pointe aprs int 3
			mov ebx,Perr
			mov edx,DWORD ptr [ebx+12]			       ;rcupre la localisation du breakpoint
			invoke lstrcpy,addr excszbreakpoint,edx						
			invoke AffichageException,Pexcept,Pcontext   	;transforme les donnes en texte
			invoke	DebugExcept					;appelle la boite de dialogue
			mov Excepttraite,0					;tout est fini,laisse la voie libre			
										; l'exception suivante
			mov excCrashAdresse,0				;rien a voir
			; ne marche pas dans ce cas,le pas a pas n'est pas amorable
			;invoke MessageBox,NULL,SADD("Continuer le trap"),SADD("Pas a pas"),MB_OKCANCEL
			;.if eax == IDOK
			;	mov (CONTEXT ptr [EBX]).ContextFlags,CONTEXT_FULL
			;	mov (CONTEXT ptr [EBX]).iDr7,NULL
			;	or (CONTEXT ptr [EBX]).regFlag,100h
			;	mov (CONTEXT ptr [EBX]).iDr6,NULL
			;.endif
			mov retour,EXCEPTION_CONTINUE_SEARCH
			jmp FindeHANDLER
		.endif
		
		MOV EDI,Perr       			;get excpointeur to ERR structure in edi
			;@@@@@@@@@@@ localise dans le source l'endroit ou s'est produit l'erreur @@@@@@@@@@@@@
		mov edx,[EDI+12]				;rcupre le nom du proc ("nom")		
		;l'utilisateur veut il passer l'erreur
		invoke   MessageBox,NULL,addr excquestion,edx,MB_YESNO       ;wait till button pressed
		.if EAX == IDYES               ;see if yes clicked 
			;sauvegarde les registres de context avant de les modifier			
			invoke AffichageException,Pexcept,Pcontext
			;montrer la boite
			invoke	DebugExcept				;appelle la boite de dialogue				
			;remplace l'adresse d'erreur contenu dans context
			;par l'adresse de retour dfini dans EXCEPT 
			MOV ESI,Pcontext       		       ;excpointeur sur context dans esi
			MOV EDI,Perr       				;charge le excpointeur sur ERR dans EDI
			MOV (CONTEXT ptr [ESI]).regEsp,EDI      	;remplace esp du CONTEXT par esp de dpart
			MOV EAX,[EDI+8]         			;rcupre l'adresse de retour			
			MOV (CONTEXT ptr [ESI]).regEip,EAX      	;charge eip du context avec l'adresse de retour
			MOV EAX,[EDI+14h]       			;rcupre l'ebp de dpart
			MOV (CONTEXT ptr [ESI]).regEbp,EAX      	;remplace l'ebp de context par l'ebp de dpart
			mov dword ptr [EDI+18h],0			;positionner retour a zero,chec
			mov Excepttraite,0	;tout est fini,etre pret pour la suivante
			;or (CONTEXT ptr [ESI]).ContextFlags,100h
			mov excCrashAdresse,0
			;----------------------------------------------------------------------------------
			mov retour,EXCEPTION_CONTINUE_SEARCH        	;recharger les registres avec les valeurs
			;contenus dans context et poursuivre l'xcution normale du programme
			;----------------------------------------------------------------------------------
			
		.else
			;donner le plus d'informations possibles sur l'incident
			;et aller a final_handler
			;faire un calcul pour voir si on peut obtenir l'adresse de retour
			;d'une fonction ventuellement appele,si chec le final_handler prendra la main
			mov edi,Pcontext
			MOV ESI,(CONTEXT ptr [EDI]).regEbp       ;si adresse d'erreur en dehors du proc
							;ebp permet de retrouver l'adresse de retour
							;si la fonction appeler n'a pas appeler
							;une autre fonction
			MOV EAX,(CONTEXT ptr [EDI]).regEip		;sauvegarde l'adresse du crash
			mov excCrashAdresse,eax
			
			;---------------- analyser les adresses obtenus			
			mov edx,excCrashAdresse				;EIP
			mov eax,DebutdeProgramme
			mov ecx,FindeProgramme ;Les lignes ne peuvent tre trouvs 
						   ;que dans le code gnr	
			;----------------------------------------------------
			.if edx >= eax && edx <= ecx	 ;edx excCrashAdresse
				mov excPositionAdresse,0            ;c'est dans le code du prog
				mov excTemoindeRetour,0
				;transformer l'adresse en symb adresse
				sub edx,DebutdeProgramme
				mov excCrashListing,edx
				mov edx,excSymRVApremiereligne   ;la premiere ligne de code crit avec un dcalage > start
				add edx,excCrashListing
				mov excSymRVAcrash,edx										
			.else
			;----------------------------------------------------------------------
				mov excPositionAdresse,1
				mov excTemoindeRetour,1			;pour numration des lignes
				.if excPresenceSymboles == 0	;sans symboles la mthode n'est que partiel
					mov excSymRVAcrash,0
					jmp AffichageRenseignents		;pas de symboles plus d'infos				
				.endif	
				
				;invoke ExplorePile,Pcontext    ;STACKWALK help me, sa ne marche pas
				;.if eax != 0 && eax < PossibleRetour ;stackwalk choue souvent sans gnrer 
				;	mov PossibleRetour,eax	   ;d'erreur
				;.endif								
				
				
				
				mov eax,DebutdeProgramme
				mov ecx,FindeProgramme 
				mov ebx,Perr
				mov edx,dword ptr [ebx+20]				
				invoke DescendrePile,Perr,edx,esp,eax,ecx,HANDLER
				.if eax == 0
					mov excPositionAdresse,2
					mov excSymRVAcrash,0
					jmp AffichageRenseignents
				.endif
				mov excSymRVAcrash,eax
			.endif	
			
			
			;------------- calcul des adresses de crash pour Sym , listing ----------
			;faire un dsassemblage avec DASM pour explications
			;crash -DebutdeProgramme=listing
			;RVA=Relative Virtual Adresse (relative au dpart DOS prog MZ...)
			;CrashListing + SymRVApremiereligne = SymRVAcrash
			;------------------------------------------------------------------------
			; SymEnumLinesProc utilise excSymRVAcrash la RVA pour les lignes de codes
			;---------------------------------------------
			invoke SymEnumLines,HprocessSym,excdwModuleBase,NULL ,NULL,NULL,\
								SymEnumLinesProc,NULL
								
			;--------------- pour affichage -----------------------
			lea ebx,excchercheligne
			assume ebx: ptr SRCCODEINFO
			mov ecx,dword ptr [ebx].LineNumber
			EXCPERMUTTEHIGHLOW ecx
			mov PlanteLigne,ecx			;pour DDE
			mov eax,dword ptr [ebx].Address
			mov excatest,eax
			EXCPERMUTTEHIGHLOW eax
			mov edx,eax			
			invoke wsprintf,addr exctampon, addr excFormatAfficheligne,\
					[ebx].SizeOfStruct,[ebx].Key,dword ptr [ebx].ModBase,addr [ebx].Obj,\
					addr [ebx].FileName,PlanteLigne,edx
			AffichageRenseignents:		
			assume ebx:NOTHING			
			MOV EDI,Perr       			;get excpointeur to ERR structure in edi
			;@@@@@@@@@@@ localise dans le source l'endroit ou s'est produit l'erreur @@@@@@@@@@@@@
			mov ebx,[EDI+12]				;rcupre le nom du proc ("nom")
			;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@			
			.if excPositionAdresse == 1			;adresse de retour recalcul
			;--------- externe au code compil -------------------------------------------------
			;-----------------------------------------------------------------------------------
				; la ligne de code prcdente a t prise par enumline proc
				;corriger le excCrashAdresse pour final handler
				mov eax,dword ptr excchercheligne.Address ;une RVA en 64 bits
				EXCPERMUTTEHIGHLOW eax		;oter la permutation
				sub eax,excSymRVApremiereligne        ;une adresse listing
				add eax,DebutdeProgramme
				mov excCrashAdresse,eax
				invoke szCatStr,addr exctampon,addr excMesretour								
				invoke dwtoa,CPTpile,addr excazer
				invoke szCatStr,addr exctampon,addr excazer
				invoke MessageBox,NULL,ADDR exctampon,ebx,MB_OK
				
			.elseif excPositionAdresse == 0		;erreur dans le code
				invoke MessageBox,NULL,ADDR exctampon,ebx,MB_OK
			.elseif excPositionAdresse == 2		;pas de solution
				invoke MessageBox,NULL,addr OubliExcept,SADD("EXCEPT manquant"),MB_OK					
			.endif
			;afficher le rsultat
			;---------------------- la fin -----------------------------------------------
			excPasserSymboles:
			MOV retour,EXCEPTION_EXECUTE_HANDLER        ;aller au handler suivant
			;va a final handler sans autre possibilit que de quitter le prog,pas de unwind
		.endif
	.elseif eax == EXCEPTION_NONCONTINUABLE
		invoke MessageBox,NULL,SADD("EXCEPTION_NONCONTINUABLE"),SADD("Titre"),MB_OK	
		MOV retour,EXCEPTION_EXECUTE_HANDLER               ;eax=1 aller au handler suivant
	.elseif eax == ExceptionNestedException			;unwind deuxieme appel de la routine
		;une partie des renseignements est perdue
		;lorsque l'on arrive a cette tape
		;dans le cas prsent elle ne sert a rien du tout
		;peut tre lorsqu'on demande le debuggage d'un thread,mais ce n'est pas le cas .
		;si vous lui trouvez une utilit,faites moi le savoir
		invoke ExitProcess,0 	;finir si final_handler n'est pas arriv a ses fins.
		;trait en premier le breakpoint,pas de messagebox
		invoke  MessageBox,0,addr excunwinding,addr except,MB_OK         ;on est pas prs de la voir
		mov retour,EXCEPTION_EXECUTE_HANDLER               ;eax=1 system to go to next handler
	.else
		invoke MessageBox,NULL,SADD("inconnu"),SADD("Titre"),MB_OK
	.endif
FindeHANDLER:
	mov eax,retour	
	RET
HANDLER endp



;################################################################
;le but est de former une phrase contenant les instructions textes
;destines au serveur.Le serveur reconnait l'action grace au mot rserv de dbut de ligne
;ii except: signifie "se dplacer a la tab et a la ligne suivante.
;----------------------------------------------------------------------
ExcEnvoyerServeurDDE PROC  FeuilleName:DWORD,  NumLigne:DWORD ,Hdialog:DWORD
			Local aApp:DWORD
			Local aTopic:DWORD			
			Local  Biatom:DWORD
			Local   phrase[MAX_PATH +1]:BYTE
			LOCAL  AsciiNum[20]:BYTE
			Local  retour:DWORD			
			EXCZEROLOCALES retour				 
	mov retour,1
	;dw2ah			
	invoke dw2hex,NumLigne,addr AsciiNum		;htodw
	invoke GlobalAddAtom,addr NomServeur
	.if eax == 0		
		invoke MessageBox,NULL,SADD("GlobalAddAtom"),SADD("Titre"),MB_OK
	.endif
	mov aApp,eax
	and eax,0FFFFh
	shl eax,16
	mov Biatom,eax
	invoke szCatStr,addr phrase,addr MarqueurDDE
	invoke szCatStr,addr phrase,FeuilleName
	invoke szCatStr,addr phrase,addr excunespace
	invoke szCatStr,addr phrase	,addr AsciiNum
	invoke GlobalAddAtom,addr phrase
	mov aTopic,eax
	and eax,0FFFFh	
	add Biatom,eax	
	invoke RegisterWindowMessage,addr MesEditmasm   ;db "WM_EDITMASM",0
	mov edx,eax
	;-----------------------------------------------------------------------
	invoke SendMessage,HWND_BROADCAST,edx,Hdialog,Biatom
	;-----------------------------------------------------------------------
	invoke GlobalDeleteAtom,aApp
	invoke GlobalDeleteAtom,aTopic	
 FindeExcEnvoyerServeurDDE:
         mov eax,retour
         ret
ExcEnvoyerServeurDDE endp


;################################################################
;en entre l'adresse des structures  EXCEPTION_RECORD et CONTEXT
;en sortie un tableau de DWORD excsauvereg ou la boite d'affichage va venir chercher
;ses donnes,plus la traduction littrale du code d'exception
;pour etre valides,les renseignements doivent etre saugegards au premier appel de handler

AffichageException PROC  Pexcept:DWORD,  Pcontext:DWORD 
			Local  retour:DWORD
	mov retour,1
	MOV EBX,Pexcept  ;EXCEPTION_RECORD       				;get exception record in ebx
	mov edx,(EXCEPTION_RECORD ptr [EBX]).ExceptionCode
	
	;------rechercher dans le tableau la chaine littrale correspondant au
	;------ numero de code exception
	lea edi,Mesexcept
	@@:
	mov excpointeur,edi
	mov ecx,60
	cld						;valeur du message d'exception
	mov al,0
	repnz scasb	;rencontre le zero de fin de chaine ,avance jusqu'au dd 
	mov eax ,dword ptr[edi]
	.if edx == eax
		jmp @F
	.endif
	add edi,8
	cmp dword ptr[edi],0
	jnz @B			;continuer la recherche
	invoke MessageBox,NULL,addr excpastrouve,ADDR excTITRE000,MB_OK	
	jmp redirige	
	@@:
	invoke lstrcpy ,addr excretourmeser,excpointeur
	redirige:
	MOV EBX,Pexcept  ;EXCEPTION_RECORD       				;get exception record in ebx
	MOV EAX,(EXCEPTION_RECORD ptr [EBX]).ExceptionFlags         	;get flag sent by the system
	; le systeme interdit t il le traitement de l'erreur ?
	.if eax == EXCEPTION_CONTINUABLE	
			MOV ESI,Pcontext       			;get excpointeur context in esi
			MOV EAX,(CONTEXT ptr [ESI]).regEax	
			mov excsauvereg[0],eax			
			MOV EAX,(CONTEXT ptr [ESI]).regEbx	
			mov excsauvereg[4],eax			
			MOV EAX,(CONTEXT ptr [ESI]).regEcx	
			mov excsauvereg[8],eax			
			MOV EAX,(CONTEXT ptr [ESI]).regEdx	
			mov excsauvereg[12],eax			
			MOV EAX,(CONTEXT ptr [ESI]).regEsi	
			mov excsauvereg[16],eax			
			MOV EAX,(CONTEXT ptr [ESI]).regEdi	
			mov excsauvereg[20],eax			
			MOV EAX,(CONTEXT ptr [ESI]).regEsp	
			mov excsauvereg[24],eax			
			MOV EAX,(CONTEXT ptr [ESI]).regEip	
			mov excsauvereg[28],eax	
			MOV EAX,(CONTEXT ptr [ESI]).regEbp
			mov excsauvereg[32],eax	
			MOV EAX,(CONTEXT ptr [ESI]).regFlag
			mov excsauvereg[36],eax				
			;pas de messagebox
	.endif


 FindeAffichageException:
         mov eax,retour
         ret
AffichageException endp

;################################################################
;c'est ce proc qui est appel lorsqu'aucun autre filtre d'exceptions
;n'a t mis en place par EXCEPT.Lorsque des filtres EXCEPT sont en place
;c'est le dernier appel

FINAL_HANDLER PROC  uses esi edi ebx ExceptionInfo:DWORD     ;le systeme passe EXCEPTION_POINTERS
; correspond a la dfinition du UnhandledExceptionFilter dans le SDK
	;lea eax,FindeProgramme
	ECHO l'tiquette DebutdeProgramme: doit suivre start
	ECHO l'tiquette FindeProgramme: doit prcder end start
	mov ebx,ExceptionInfo
	mov edx,DWORD ptr [ebx]		;pExceptionRecord
	mov excminidumppExceptionRecord,edx	
	mov ecx,DWORD ptr [ebx+4]		;PCONTEXT
	mov excminidumpContext,ecx
	
	;aucune localisation possible dans le source ii
	;ce qui rend les rattrapages possibles fort peu nombreux
	;l'int 3 pourrait etre de celles la mais
	;le FINAL_HANDLER doit jouer son rle de dernier rempart contre l'cran bleu
	;quitte a finir un peu trop tot	
	
	invoke AffichageException,edx,ecx   	;transforme les donnes en texte	        
	invoke	DebugExcept				;appelle la boite de dialogue	
	
		mov ebx,ExceptionInfo
		mov edi,DWORD ptr [ebx+4]
		MOV Edx,(CONTEXT ptr [EDI]).regEip		;sauvegarde l'adresse du crash
		.if excCrashAdresse != 0
			mov edx,excCrashAdresse
		.endif
		mov eax,DebutdeProgramme ;start est allou dynamiquement,autrement dit dplac
		mov ecx,FindeProgramme	
		;
		.if edx >= eax && edx < ecx			;erreur dans le code du programme
				sub edx,eax
				invoke dw2hex,edx,addr excazer
				.if excPositionAdresse != 1
					invoke MessageBox,NULL,ADDR excazer,SADD("adresse listing"),MB_OK
				.else
					invoke MessageBox,NULL,ADDR excazer,SADD("adresse listing reconstitue a partir du retour"),MB_OK
				.endif
		.else
			invoke MessageBox,NULL,SADD("localisable uniquement par phrase d'EXCEPT ,probable appel API"),\
						SADD("adresse non localise dans le source"),MB_OK			
		.endif
	invoke MessageBox,NULL,SADD("Crer un MINIDUMP ?"),SADD("Rapport de Bug"),MB_OKCANCEL
	.if eax == IDOK
		invoke Minidump
	.endif
	;si on est la,c'est qu'aucune solution de continuation du programme
	;n'existe (exception dans une zone non protge par except) ou
	;que les handlers n'ont pas non plus de solutions pour continuer le programme donc !!
	;------------------------------------------------------------------------------------------
	invoke ExitProcess,0FFh 	;***************** finir proprement **************************
	;-------------------------------------------------------------------------------------------
	;En rsum on a deux solutions en cas d'exceptions
	;-------soit le handler et uniquement lui procde a la continuation du programme
	;-------soit le final handler affiche les informations sur l'exception et termine le programme
	;puisque il est inutile de revenir par unwind aux handlers,ils n'auront pas plus de solutions
	; si votre imagination entrevoie une troisieme solution , n'hsiter pas m'en faire part
	;de l'expos ci dessus , on peut dduire que certaines fonctions sont inutiles
	;il s'agit de RtlUnwind et de RaiseException
	

	MOV EAX,EXCEPTION_EXECUTE_HANDLER               ; handler suivant s'il existe ,unwind
	;0 provoque un crash dans certains cas
	;mov eax,EXCEPTION_CONTINUE_SEARCH    ;0 droulement normal , finir
	RET 
FINAL_HANDLER endp


;################################################################
DebugExcept  PROC
		; appel de la boite de dialogue
		local valeurinitialisation :DWORD
		ExceptInsTxt zzzzDebugExcept,"IDD_EXCEPT"
			mov eax,NULL
			mov valeurinitialisation,eax
			;*** Fenetre principale et boite constitue 2 progs separs ou presque ! *******
			; invoke CreateDialogParam,HExceptInstance, addr zzzzDebugExcept,NULL,OFFSET DlgDebugExcept,valeurinitialisation
			;le process se reboucle dans la boite et invalide la fenetre principale
			invoke DialogBoxParam,HExceptInstance, addr zzzzDebugExcept,NULL,OFFSET DlgDebugExcept,valeurinitialisation
			;invoke SetFocus,hREdit
	
FindeDebugExcept:
ret
DebugExcept endp
	
;################################################################
	
DlgDebugExcept  PROC HdialBox:DWORD,wmsg:DWORD,wparam:DWORD, lparam:DWORD
	Local HListBox1:DWORD
	Local phrase[MAX_PATH]:BYTE		
		; gere les evenements
	.if     wmsg == WM_INITDIALOG
		mov edx,excsauvereg[0]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIEAX,WM_SETTEXT,0,addr phrase
		mov edx,excsauvereg[4]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIEBX,WM_SETTEXT,0,addr phrase
		mov edx,excsauvereg[8]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIECX,WM_SETTEXT,0,addr phrase
		mov edx,excsauvereg[12]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIEDX,WM_SETTEXT,0,addr phrase
		mov edx,excsauvereg[16]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIESI,WM_SETTEXT,0,addr phrase
		mov edx,excsauvereg[20]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIEDI,WM_SETTEXT,0,addr phrase
		mov edx,excsauvereg[24]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIESP,WM_SETTEXT,0,addr phrase
		mov edx,excsauvereg[28]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIEIP,WM_SETTEXT,0,addr phrase
		mov edx,excsauvereg[32]
		invoke dw2hex,edx,addr phrase
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIEBP,WM_SETTEXT,0,addr phrase
		
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIFAUTE,WM_SETTEXT,0,addr excretourmeser
		;------------------- flag---------------------------------------------------
		invoke Copier,addr phrase,addr flag18
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK AC
		shr eax,18
		add eax,30h
		stosb
		invoke Copier,edi,addr flag17
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK VM
		shr eax,17
		add eax,30h
		stosb
		invoke Copier,edi,addr flag16
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK RF
		shr eax,16
		add eax,30h
		stosb
		invoke Copier,edi,addr flag15		;nul
		add edi,ecx
		invoke Copier,edi,addr flag14
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK NF
		shr eax,14
		add eax,30h
		stosb
		invoke Copier,edi,addr flag13
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK IO
		shr eax,13
		add eax,30h
		stosb
		invoke Copier,edi,addr flag12
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK PL
		shr eax,12
		add eax,30h
		stosb
		invoke Copier,edi,addr flag11
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK OF
		shr eax,11
		add eax,30h
		stosb
		invoke Copier,edi,addr flag10
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK _DF
		shr eax,10
		add eax,30h
		stosb
		mov al,0
		stosb
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIFLAG1,WM_SETTEXT,0,addr phrase
		
				; -------
		invoke Copier,addr phrase,addr flag9
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK _IF
		shr eax,9
		add eax,30h
		stosb
		invoke Copier,edi,addr flag8
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK TF
		shr eax,8
		add eax,30h
		stosb
		invoke Copier,edi,addr flag7
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK SF
		shr eax,7
		add eax,30h
		stosb
		invoke Copier,edi,addr flag6
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK ZF
		shr eax,6
		add eax,30h
		stosb
		invoke Copier,edi,addr flag5		;nul
		add edi,ecx
		invoke Copier,edi,addr flag4
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK AF
		shr eax,4
		add eax,30h
		stosb
		invoke Copier,edi,addr flag3		;nul ou 1
		add edi,ecx
		invoke Copier,edi,addr flag2
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK PF
		shr eax,3
		add eax,30h
		stosb
		invoke Copier,edi,addr flag1		;nul
		add edi,ecx
		invoke Copier,edi,addr flag0
		mov edi,eax
		add edi,ecx
		mov eax,excsauvereg[36]
		and eax,MASK CF
		add eax,30h
		stosb
		mov al,0
		stosb		
		invoke SendDlgItemMessage,HdialBox,IDC_EXCEPTETIFLAG2,WM_SETTEXT,0,addr phrase
		mov eax,dword ptr [excszbreakpoint]
		.if eax != 0
			;localise le point d'arret
			invoke SendMessage,HdialBox,WM_SETTEXT,NULL,addr excszbreakpoint
			invoke RtlZeroMemory,addr excszbreakpoint,sizeof excszbreakpoint
		.endif
		invoke ExcEnvoyerServeurDDE,addr excchercheligne.FileName,PlanteLigne,HdialBox
		mov eax, TRUE ;windows attribue le focus ( la ou va se placer le curseur )
		ret
		;return FALSE ; la boite a defini le focus
	.elseif wmsg == WM_CLOSE
		 invoke EndDialog,HdialBox,NULL
	.elseif wmsg == WM_COMMAND
		EXCEPTHIWORD wparam	;evenements des listbox ,combo sont ici
		mov edx,eax
		EXCEPTLOWORD wparam	;IDentificateurs de  commandes
		mov ebx,lparam	; handle du controle
		.if 	eax == IDC_EXCEPTBUTTON1 	;remplacer par ID boutons ....
			INVOKE     GetDlgItemText, HdialBox, IDC_EXCEPTEDIT1, addr szEXCEPTEDIT1, 10
			INVOKE     SendMessage,HdialBox , WM_CLOSE, 0 ,0
		.elseif eax == 1
		.endif
	.else
		mov eax,FALSE
		jmp FindeDlgDebugExcept
	.endif
	mov  eax,TRUE
FindeDlgDebugExcept:
	ret
DlgDebugExcept endp

;-----------------------------------------------symboles -----------------------------------------
;################################################################
;utilise un maximum de fonctions Sym pour les avoir prtes a l'emploi
;################################################################
;raliser avec la dll dbghelp 6.1
;les fonctions sont rduites au minimum pour autoriser la 5.1 pour XP
;voir 4... pour 98.Pour Upgrader lib + inc (lib dans SDK inc, l2inca de MASM)
;signaler dans bugslayer bug dans certaines fonctions
;toutes les fonctions ne sont pas utiles,servent d'exemples (fort utiles)

InitialisationSymboles PROC 
			LOCAL imgline:IMAGEHLP_LINE
			LOCAL excMemInfo:MEMORY_BASIC_INFORMATION
			LOCAL Oldprotect:DWORD
			LOCAL oldoptions:DWORD
			LOCAL retour:DWORD
			EXCZEROLOCALES retour
			
        mov retour,1
	invoke InitialiseSymPath
	;pour un debugueur,si les symboles sont ceux du debugger,le numro de process et de thread doivent tre
	;ceux du debugger,changer ventuellement fInvadeProcess de SymInitialize a true
	invoke GetCurrentThread       ;a tester
	mov HthreadSym,eax
	invoke GetCurrentProcess
	mov HprocessSym,eax
	;virtualquery failed !
	;ne fonctionne qu'avec une structure (excMemInfo) en pile ?!!!!!
	
	;---------------------------------- init pure ---------------------------------------
	;charger les symboles,le .pdb gnr avec link /PDB:debut.pdb
	;invoke SymInitialize,NULL,NULL,FALSE
	;------------------------------------------------------------------------------------
	invoke SymGetOptions
	mov oldoptions,eax
	or oldoptions,SYMOPT_LOAD_LINES
	invoke SymSetOptions,oldoptions
	
	invoke SymInitialize,HprocessSym,addr excSymbolsPath,FALSE
	;--------------------------------------------------------------------------------------
	.if eax == FALSE
		InsTxt SymERR200, "SymInitialize failed"		
		invoke RetrouveMessageErreur, ADDR SymERR200	; la boite de message
		mov retour,0
		jmp FindeInitialisationSymboles		
	.endif

	;---------------------------------------------------------------------------------------	
	;invoke SymLoadModule,HprocessSym,HthreadSym,addr excNomDebugger , 0,NULL, 0
	invoke SymLoadModule,HprocessSym,NULL,addr excNomDebugger , 0,NULL, 0
	;---------------------------------------------------------------------------------------
	.if eax == 0
		InsTxt SymERR002, "SymLoadModule pas de fichier de debuggage"		
		invoke RetrouveMessageErreur, ADDR SymERR002	; la boite de message
		mov retour,0
		jmp FindeInitialisationSymboles ;Fermerleshandles
	.else
		;***** prciser uniquement dans le sdk ,renvoie l'adresse de base du module *******
		;qui peut tre obtenu par SymEnumerateModules aussi
		mov excdwModuleBase,eax   ;winhelp diffre en disant TRUE
		invoke dw2hex,excdwModuleBase,addr exctampon
		;invoke MessageBox,NULL,addr exctampon,SADD(" SymLoadModule "),MB_OK
		
	.endif
	;les fonctions d'numrations sont en plus grand nombre dans versions suprieures
	invoke SymEnumerateModules,HprocessSym,offset EnumModulesCallback,NULL
	.if eax == 0
		InsTxt SymERR000, "SymEnumerateModules"		; Nom de la fonction ayant echou
		invoke RetrouveMessageErreur, ADDR SymERR000	; la boite de message
		mov retour,0
	.endif		

	
	;-----voir si le module n'est pas vide
	;--------------IMAGEHLP_MODULE remplace IMAGE_DEBUG_INFORMATION------------
	;--------seulement XP -------------------------------------------
	
	mov excModuleImagehelp.SizeOfStruct,sizeof IMAGEHLP_MODULE			
	invoke SymGetModuleInfo,HprocessSym,excdwModuleBase,addr excModuleImagehelp
	.if excModuleImagehelp.SymType1 == SymExport || excModuleImagehelp.SymType1 == SymNone
		invoke MessageBox,NULL,SADD("Symboles d exportations ou pas de symboles"),\
					SADD("SymGetModuleInfo"),MB_OK
		invoke SymUnloadModule,NULL, excdwModuleBase
		mov retour,0
		jmp FindeInitialisationSymboles ;Fermerleshandles
	.else
		;invoke MessageBox,NULL,ADDR excModuleImagehelp.ModuleName,SADD("SymGetModuleInfo"),MB_OK
	.endif
	
	
	;a mettre en premier pour avoir une structure de ligne correcte
	;invoke MessageBox,NULL,ADDR objet,SADD("fichier objet"),MB_OK
	;addr objet
	;a partir de 6.1,l'arret par retour ne fonctionne pas
	;fourni les informations de lignes par dfaut ncessaires a la suite de fonctions
	;toutes les fonctions dans le commentaire ont t tests
					
	mov excCPT,0
	invoke SymEnumLines,HprocessSym,excdwModuleBase,NULL ,NULL,NULL,\
			SymEnumLinesProc,NULL
	.if eax == 0
		InsTxt SymERR060, "SymEnumLines"	; Nom de la fonction ayant echou					
		invoke RetrouveMessageErreur, ADDR SymERR060	; la boite de message
		mov retour,0
		jmp FindeInitialisationSymboles		
	.endif
	
	invoke SymEnumSourceFiles,HprocessSym,excdwModuleBase,NULL,\
			NULL, EnumSourceFilesCallback, NULL 
	.if eax == 0
		InsTxt SymERR102, "SymEnumSourceFiles "		
		invoke RetrouveMessageErreur, ADDR SymERR102	; la boite de message
		mov retour,0
		jmp FindeInitialisationSymboles		
	.endif
	;--------------------------- ne marche pas -------------
	;mov  moduleinfo.SizeOfStruct ,sizeof IMAGEHLP_MODULE64
	;invoke SymGetModuleInfo64,HprocessSym,excdwModuleBase,NULL,addr moduleinfo
	;.if eax == 0
	;		InsTxt SymERR063, "SymGetModuleInfo64 failed"	; Nom de la fonction ayant echou					
	;		invoke RetrouveMessageErreur, ADDR SymERR063	; la boite de message				
	;.endif
	
	mov excsLigne.SizeOfStruct,sizeof IMAGEHLP_LINE	
	;a corriger ,la premiere ligne numre est prise par dfaut
	;ou sinon il faut lire le source pour passer un numro de ligne
	;contenant du code
	invoke SymGetLineFromName,HprocessSym,addr excModuleImagehelp.ModuleName,\
			addr excPremierSource,excPremiereLigne,addr excdeplacement,addr excsLigne
	.if eax == 0
		InsTxt SymERR062, "SymGetLineFromName"	; Nom de la fonction ayant echou					
		invoke RetrouveMessageErreur, ADDR SymERR062	; la boite de message				
		mov retour,0
		jmp FindeInitialisationSymboles
	.endif
	@@:
	;------------------------ remonter a la premiere ligne --------------------
	invoke SymGetLinePrev,HprocessSym,addr excsLigne ;TestAdresse,addr pdwDisplacement,
	.if eax != 0			
		;invoke AfficheRegistre,excsLigne.Address,SADD("SymGetLinePrev adress") 
		;invoke MessageBox,NULL,excsLigne.FileName,SADD("source"),MB_OK		
		
		PuPo excdecalage,excsLigne.Address
		
		;invoke AfficheRegistre,excsLigne.LineNumber,SADD("SymGetLinePrev numro ligne") 
		;invoke SymGetLineFromAddr,HprocessSym,excsLigne.Address,addr excdeplacement,addr imgline   ;,excdwModuleBase
		
		jmp @B
		
		;.if eax != 0
		;invoke AfficheRegistre,excdeplacement,SADD("SymGetLineFromAddr numro ligne")
		;.if eax == 0  ;.else
		;	mov retour,0
		;	jmp FindeInitialisationSymboles
		;.endif
	.else
		mov ecx,excdecalage		;calcul rva premiere ligne Sym
		sub ecx,excdwModuleBase
		mov excSymRVApremiereligne,ecx
	.endif

	;-----------------------------------------------------------------------------------	

	invoke  SymEnumerateSymbols,HprocessSym, excdwModuleBase, offset CallbackEnumerateSymbols, 0 
	.if eax == 0
		InsTxt SymERR001, "SymEnumerateSymbols chec"		; Nom de la fonction ayant echou
		invoke RetrouveMessageErreur, ADDR SymERR001	; la boite de message
		mov retour,0
		jmp FindeInitialisationSymboles
	.endif		
	
 FindeInitialisationSymboles:
         mov eax,retour
         ret
InitialisationSymboles endp
;################################################################


InitialiseSymPath PROC uses edi
			Local  retour:DWORD
			;Local    [256]:BYTE 
         	mov retour,1
		invoke GetModuleFileName,NULL,addr excNomDebugger,sizeof excNomDebugger
		invoke GetFullPathName,addr excNomDebugger,sizeof excSymbolsPath,addr excSymbolsPath,addr excPosnomCourt
		mov edi,excPosnomCourt
		mov al,0
		stosb				;forme le path des symboles termin par un \
		;invoke MessageBox,NULL,ADDR excNomDebugger,addr excSymbolsPath,MB_OK
		
		;excSymbolsPath
 FindeInitialiseSymPath:
         mov eax,retour
         ret
InitialiseSymPath endp


;################################################################
EnumModulesCallback PROC  uses esi edi ebx ModuleName:DWORD, BaseOfDll :DWORD, UserContext :DWORD 
			Local  retour:DWORD
			;Local   :DWORD
			;Local    [256]:BYTE excFormatAffichemodule
       mov retour,TRUE ;FALSE arrete l'numration
	invoke wsprintf,addr exctampon, addr excFormatAffichemodule,\
			ModuleName,BaseOfDll,UserContext
	;invoke MessageBox,NULL,addr exctampon,SADD("EnumModulesCallback"),MB_OK

 FindeEnumModulesCallback:
         mov eax,retour
         ret
EnumModulesCallback endp


;################################################################
EnumSourceFilesCallback PROC uses esi edi ebx pSourceFile:DWORD,  UserContext:DWORD 
			Local  retour:DWORD ;pSourceFile
         mov retour,FALSE ;TRUE ;FALSE arrete l'numration
		mov ebx,pSourceFile
		mov edx,(SOURCEFILE ptr [ebx]).FileName
	;invoke MessageBox,NULL,edx,SADD("Enumre les sources du projet"),MB_YESNO
	.if eax == IDYES
		mov retour,TRUE
	.endif
 FindeEnumSourceFilesCallback:
         mov eax,retour
         ret
EnumSourceFilesCallback endp

;################################################################

CallbackEnumerateSymbols PROC uses esi edi ebx SymbolName:DWORD,SymbolAddress:DWORD,\
							SymbolSize:DWORD,UserContext :DWORD 
			Local  retour:DWORD
			Local phrase[MAX_PATH]:BYTE
         mov retour,TRUE ;FALSE arrete l'numration
  	invoke lstrcpy,addr exctampon,SymbolName
	invoke szCatStr,addr exctampon,addr excespace
	
	invoke dw2hex,SymbolAddress,addr phrase
	invoke szCatStr,addr exctampon,addr phrase
	invoke szCatStr,addr exctampon,addr excespace
	
	invoke dw2hex,SymbolSize,addr phrase
	invoke szCatStr,addr exctampon,addr phrase

	;invoke MessageBox,NULL,ADDR exctampon,SADD("enumere les symboles"),MB_YESNO
	.if eax == IDNO
         	mov retour,FALSE ;arrete l'numration		
	.endif
 FindeEnumerateSymbolsCallback:
         mov eax,retour
         ret
CallbackEnumerateSymbols endp

;
;-----	l'adresse du crash a t prcdemment transforme en excSymRVAcrash
;-----	excchercheligne contient la rponse
;----- excMemoSRCCODE mmorise la ligne de code prcdente
;----- la premiere ligne de code fournit des infos d'init a d'autres fonctions SymGetLineFromName
; dans initialisation des symboles
;################################################################
SymEnumLinesProc PROC uses esi edi ebx LineInfo:DWORD,UserContext:DWORD 
			Local  retour:DWORD
         		mov retour,TRUE			;ne sortir que la premiere ligne ne marche pas
			inc excCPT
			mov ebx,LineInfo
			assume ebx: ptr SRCCODEINFO			
			.if excCPT > 1
				jmp parcours ; UserContext et retour ne marche pas
			.endif
			;----- rfrence premiere ligne valide --------						
			mov ecx,dword ptr [ebx].LineNumber
			mov excPremiereLigne,ecx			;premiere ligne valide			
			EXCPERMUTTEHIGHLOW ecx
			mov eax,dword ptr [ebx].Address
			mov excatest,eax
			EXCPERMUTTEHIGHLOW eax
			mov edx,eax
			invoke wsprintf,addr exctampon, addr excFormatAfficheligne,\
					[ebx].SizeOfStruct,[ebx].Key,dword ptr [ebx].ModBase,addr [ebx].Obj,\
					addr [ebx].FileName,ecx,edx
			assume ebx:NOTHING
			;invoke MessageBox,NULL,ADDR exctampon,SADD("SymEnumLinesProc"),MB_OK
			lea edx,(SRCCODEINFO ptr [ebx]).FileName
			invoke lstrcpy,addr excPremierSource,edx
			
			;-------------------------------------------------------------------------------
			parcours:
			.if excCrashAdresse == 0
				jmp FindeSymEnumLinesProc
			.endif
			;excTemoindeRetour
			mov ebx,LineInfo
			assume ebx: ptr SRCCODEINFO	
			;l'adresse du crash a t prcdemment transforme en excSymRVAcrash
			mov edx,excSymRVAcrash
			mov eax,dword ptr [ebx].Address ;QWORD 64 bits permuttant high low du 32
			EXCPERMUTTEHIGHLOW eax		;limite a 64k le code 
			.if edx == eax; 
				.if excTemoindeRetour == 0
					;la solution est la ligne actuelle
					mov esi,LineInfo
					lea edi,excchercheligne
					mov ecx,sizeof SRCCODEINFO
					cld
					rep movsb
				.else
					;la solution est la ligne de code prcdente
					lea esi,excMemoSRCCODE
					lea edi,excchercheligne
					mov ecx,sizeof SRCCODEINFO
					cld
					rep movsb
					
				.endif
			.else
				mov esi,LineInfo		;mmorise ligne
				lea edi,excMemoSRCCODE
				mov ecx,sizeof SRCCODEINFO
				cld
				rep movsb						
			.endif
			;affichage
			lea ebx,excchercheligne
			assume ebx: ptr SRCCODEINFO
			mov ecx,dword ptr [ebx].LineNumber
			EXCPERMUTTEHIGHLOW ecx
			mov eax,dword ptr [ebx].Address
			EXCPERMUTTEHIGHLOW eax
			mov edx,eax			
			invoke wsprintf,addr exctampon, addr excFormatAfficheligne,\
					[ebx].SizeOfStruct,[ebx].Key,dword ptr [ebx].ModBase,addr [ebx].Obj,\
					addr [ebx].FileName,ecx,edx
			;invoke MessageBox,NULL,ADDR exctampon,SADD("solution intermdiaire"),MB_OK
			assume ebx:NOTHING

			
 FindeSymEnumLinesProc:
         mov eax,retour
         ret
SymEnumLinesProc endp

;---------------------------------------------------------------------------------------------
AfficheRegistre PROC  registre:DWORD,  adrTitre:DWORD 
			Local  retour:DWORD
			Local  Tampon[30]:BYTE 
			pushad
         mov retour,1	
			mov edx,registre
			invoke dw2hex,edx,addr Tampon		
			invoke MessageBox,NULL,addr Tampon,adrTitre,MB_OK

 FindeAfficheRegistre:
		popad
        ; mov eax,retour
         ret
AfficheRegistre endp
;################################################################

remontepile PROC uses esi BasePointeur:DWORD,limite1:DWORD,limite2:DWORD
			Local  retour:DWORD
	;--- un coup d'oeil sur la pile,en n'excluant pas l'chec
	;esi contient EBP du context
	;A l'appel ,les variables passs au proc sont pousss en pile,Ensuite vient 
	;l'adresse de retour(chargement de EIP au moment du retour) .A l'entre 
	;dans le proc,EBP est charg en pile , prend la valeur de ESP et sert de pointeur pour 
	;l'adresse de retour.De l'espace est allou en pile pour les variables locales 
	;et ESP pointe en fin de chaine.
	;					@ de retour
	;					ancien EBP
	;registre EBP pointe	l'ancien EBP				
			
         mov retour,0
	  mov CPTpile,0
	  	
		   mov esi,BasePointeur
		@@:
		inc CPTpile
		mov edx,[ESI+4]   		;adresse de retour
		.if  edx >= limite1 && edx <= limite2
			mov retour,edx
		.else
			invoke IsBadCodePtr,esi
			.if eax != 0
				jmp Finderemontepile
			.endif
			mov esi,[esi]		;charge l'ancien ebp,si le proc modifie EBP....
			.if CPTpile < 11	;limite arbitraire
				jmp @B
			.else
				jmp Finderemontepile
			.endif
		.endif
 Finderemontepile:
         mov eax,retour
         ret
remontepile endp

;################################################################
;mthode brutale et quelque peu imparable ,pour etre valide l'adresse doit appartenir
;a l'espace code limit par debutdeprogramme ,findeprogramme, avoir t rpertori dans le .PDB
;comme une adresse d'instruction et tre la dernire en pile
;
;-------- ne marche plus si pile dtruite ( oubli de ret,espace pile insuffisant pour construire un proc) 
;autre mthode
;chercher une valeur d'ebp prcd d'une adresse contenu dans le code,limite au call avec para


DescendrePile PROC  uses esi edi ebx err:dword,excBasePointeur:DWORD,fin:DWORD,limite1:DWORD,\
					limite2:DWORD,LastHANDLER:DWORD
			LOCAL  SuiviEbp:DWORD
			LOCAL  SuivreAdresse:DWORD
			LOCAL  FiableAdresse:DWORD
			Local  adresse:DWORD
			Local  TestAdresse:DWORD
			LOCAL  SauveCrash:DWORD
			LOCAL  cpt:DWORD
			LOCAL  conserve:SRCCODEINFO
			Local  retour:DWORD
			EXCZEROLOCALES retour
			
;la fonction reoit ancien ebp sauvegard par EXCEPT,pERR et esp avant son appel
;le but consiste a chercher ebp en descendant cet espace pour retrouver ebp
;mis en pile par l'appel de fonction,au dessus de cette adresse se trouve l'adresse de retour			 
;pile					@ de retour
;					ancien EBP
;instructions				Eip en pile
;					push EBP
;					mov ebp,esp			;ebp prend la valeur du pointeur 
;					sub esp,Taille des locales	;sur son ancienne valeur
;le premier trouv est l'ebp sauvard par le invoke dans except
;la valeur du pointeur sur cet ebp est alors le nouvel ebp a suivre
;				deux ebp identiques
;			EBP except EBP 1 invoke
;			nouvel ebp= pointeur sur le 2 ebp
;

         	mov retour,0
		mov CPTpile,0
		mov FiableAdresse,0
		mov SuivreAdresse,2			;2,on ne sait pas ce qu'on cherche
		mov adresse,0		
		mov eax,excBasePointeur		;ebp sauvegard par EXCEPT
		
		mov SuiviEbp,eax
		mov edx,SuiviEbp
		mov ecx,err
		sub ecx,fin
		mov esi,err
		sub esi,4
		sub ecx,4     ;on cherche un dword
		mov cpt,ecx				
		;partir du haut
		;on peut chercher ebp , mais celui ci n'est prsent qu'avec des locales
		;------------------- recherche adresse + enregistrement sym ligne de code --------------
		descentepile:
		mov edx,dword ptr SS:[esi]	;premiere valeur 
		mov TestAdresse,edx		;sauvegarde adresse
		;--------- premier filtre,une adresse dans la section code
		.if  edx >= limite1 && edx <= limite2 
			inc CPTpile		; indice de fiabilit
			;est ce du code en pile ?
			lea edi,excchercheligne
			mov ecx,sizeof SRCCODEINFO
			cld
			mov al,0
			rep stosb			;effacer le tampon
			mov edx,TestAdresse
			sub edx,DebutdeProgramme
			mov eax,excSymRVApremiereligne   ;la premiere ligne de code crit avec un dcalage > start
			add edx,eax				;adre listing + adr 1 ligne
			mov excSymRVAcrash,edx            ;la valeur a compare aux adresses de lignes codes
			;-------------------- trier adresse de data et de code en pile -----------------
			;--------- deuxime filtre,une adresse d'instruction reconnue par sym ----------			
			;---- la fonction utilise excSymRVAcrash comme rfrence d'adresse a trouver ---
			
			invoke SymEnumLines,HprocessSym,excdwModuleBase,NULL ,NULL,NULL,\
							SymEnumLinesProc,NULL
			mov eax,excchercheligne.LineNumber		;tampon non null
			;une valeur a t trouv ?
			.if eax != 0 	;passer le premier invoke contenu dans except
				mov  eax,dword ptr excchercheligne.Address
				mov retour,eax    ;retour <> 0 mais ce n'est pas fini
				push esi
				;sauvegarder temporairement le rsultat , poursuivre la recherche
				lea esi,excchercheligne
				lea edi,conserve
				mov ecx,sizeof SRCCODEINFO
				rep movsb
				pop esi
				jmp Nouveaupointeur  ;tant que la pile n'est pas compltement explore
				;affichage
				lea ebx,excchercheligne		;la variable contenant la rponse
				assume ebx: ptr SRCCODEINFO
				mov ecx,dword ptr [ebx].LineNumber
				shr ecx,16
				mov edx,dword ptr [ebx].Address
				shr edx,16			
				invoke wsprintf,addr exctampon, addr excFormatAfficheligne,\
						[ebx].SizeOfStruct,[ebx].Key,dword ptr [ebx].ModBase,addr [ebx].Obj,\
						addr [ebx].FileName,ecx,edx
				invoke MessageBox,NULL,ADDR exctampon,SADD("Ligne de code"),MB_OK						
			.endif			
		.endif
		Nouveaupointeur:
		dec esi
		dec cpt
		jz @F
		jmp descentepile
		@@:
		reponse:
		.if retour != 0
		;ligne de code au plus prs du bug,presque surement dessus
		;rajouter un EXCEPT sur cette ligne au cas ou ce ne serait pas le cas
		;EXCEPT n'est jamais a court de munitions
			lea edi,excchercheligne
			lea esi,conserve
			mov ecx,sizeof SRCCODEINFO
			rep movsb			
		.endif
		
 FindeDescendrePile:
         mov eax,retour
         ret
DescendrePile endp


;################################################################
Minidump PROC   uses edi
			local PosnomCourt:DWORD
			Local  Hthreadid:DWORD
			Local Htread:DWORD
			Local  retour:DWORD
	;-------- form le nom .dmp ----------------
	invoke GetModuleHandle,NULL
	mov edx,eax				
	invoke GetModuleFileName,edx,addr excCheminmodule,MAX_PATH + 1
	invoke GetFullPathName,addr excCheminmodule,sizeof excCheminDump,addr excCheminDump,addr PosnomCourt
	mov edi,PosnomCourt
	mov ecx,MAX_PATH ;c'est un .exe .dll .ocx ,on est sur de trouver un point
	mov al,"."
	cld
	repnz scasb
	mov al,0
	stosb		;coup l'extension reste .
	invoke szCatStr,addr excCheminDump,addr excExtDmp
	;-------- crer le fichier dump ----------------------
	invoke OuvrirEcriturew,addr excCheminDump
	mov excHsortie,eax
	;------------- cer le thread ---------------------------------
	invoke CreateThread,NULL,NULL,ThreadMinidump,NULL,NULL,addr Hthreadid
	mov Htread,eax
	invoke WaitForSingleObject,Htread ,INFINITE
	invoke CloseHandle,Htread				
	invoke CloseHandle,excHsortie		
         mov retour,1

 FindeMinidump:
         mov eax,retour
         ret
Minidump endp


;################################################################
ThreadMinidump PROC  parametre:DWORD
			Local  Hprocess:DWORD
			Local  Processid:DWORD
			LOcal  idththread:DWORD
			LOCAL  minidumpexceptinfo:MINIDUMP_EXCEPTION_INFORMATION
			LOCAL	minidumpexceptpointeurs:EXCEPTION_POINTERS			
			Local  retour:DWORD
			EXCZEROLOCALES retour
			
         mov retour,1
				;exemple c utilise une  version unicode pour createfilew
				invoke GetCurrentProcess
				mov Hprocess,eax				
				invoke GetCurrentProcessId
				mov Processid,eax
				invoke GetCurrentThreadId
				mov idththread,eax
				;
				mov eax,idththread ;DBEvent.dwThreadId
				mov minidumpexceptinfo.ThreadId,eax
				lea eax,minidumpexceptpointeurs
				mov minidumpexceptinfo.ExceptionPointers,eax				
				mov minidumpexceptinfo.ClientPointers,FALSE ;
				;
				;pass l'adresse d'une structure EXCEPTION_RECORD
				;si debugg par createprocess DBEvent.u.Exception.pExceptionRecord
				mov eax,excminidumppExceptionRecord
				mov minidumpexceptpointeurs.pExceptionRecord,eax
				;pass l'adresse d'une structure CONTEXT
				mov eax,excminidumpContext
				mov minidumpexceptpointeurs.ContextRecord,eax
				
				; BaseDebug.hProcess DBEvent.dwProcessId
				invoke MiniDumpWriteDump,Hprocess,Processid ,excHsortie,\
						MiniDumpNormal+MiniDumpFilterMemory,\
						addr minidumpexceptinfo,NULL,NULL
				.if eax == FALSE
					InsTxt	MsgERR230, "MiniDumpWriteDump"		
					invoke RetrouveMessageErreur, ADDR MsgERR230	; la boite de message
					mov retour,0
				.else
					mov retour,1
				.endif

 FindeThreadMinidump:
         mov eax,retour
         ret
ThreadMinidump endp

; #########################################################################
OuvrirEcriturew proc NomaOuvrir:Dword
			Local long:DWORD
			local unicode[(MAX_PATH +1)*2]:BYTE
			EXCZEROLOCALES unicode			
		;transformer le nom du fichier en unicode
		invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,NomaOuvrir,-1,addr unicode,sizeof unicode
	       ;crer le fichier	
           invoke CreateFileW,addr unicode,GENERIC_WRITE + GENERIC_READ ,NULL,\
                        NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
          .if eax == INVALID_HANDLE_VALUE
          		InsTxt TitrEcrit,"erreur ouverture fichier ",0
          		invoke  MessageBox,NULL,ADDR TitrEcrit,SADD("OuvrirEcriturew"),MB_OK
              	ret
          .endif
            
             ret
OuvrirEcriturew endp

;################################################################
InstalleExceptions PROC adrcheminlib:DWORD,debut:DWORD,fin:DWORD
			Local  retour:DWORD
         mov retour,1
	PuPo DebutdeProgramme,debut
	PuPo FindeProgramme,fin
;-------installation de la dll -------------------
	invoke LoadLibrary,adrcheminlib
	mov Hlibrairie,eax
	mov retour,eax
	.if eax == 0
		invoke RetrouveMessageErreur, SADD("LoadLibrary failed")
		mov retour,0
		jmp FindeInstalleExceptions
	.endif
		
	invoke GetProcAddress,Hlibrairie,SADD("DbgHelpCreateUserDump")
	mov ADbgHelpCreateUserDump,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("DbgHelpCreateUserDump")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("EnumDirTree")
	mov AEnumDirTree,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("EnumDirTree")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("EnumerateLoadedModules")
	mov AEnumerateLoadedModules,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("EnumerateLoadedModules")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("EnumerateLoadedModules64")
	mov AEnumerateLoadedModules64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("EnumerateLoadedModules64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("EnumerateLoadedModulesW64")
	mov AEnumerateLoadedModulesW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("EnumerateLoadedModulesW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("FindDebugInfoFile")
	mov AFindDebugInfoFile,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("FindDebugInfoFile")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("FindDebugInfoFileEx")
	mov AFindDebugInfoFileEx,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("FindDebugInfoFileEx")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("FindExecutableImage")
	mov AFindExecutableImage,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("FindExecutableImage")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("FindExecutableImageEx")
	mov AFindExecutableImageEx,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("FindExecutableImageEx")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("FindFileInPath")
	mov AFindFileInPath,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("FindFileInPath")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("FindFileInSearchPath")
	mov AFindFileInSearchPath,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("FindFileInSearchPath")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("GetTimestampForLoadedLibrary")
	mov AGetTimestampForLoadedLibrary,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("GetTimestampForLoadedLibrary")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("ImageDirectoryEntryToData")
	mov AImageDirectoryEntryToData,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("ImageDirectoryEntryToData")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("ImageDirectoryEntryToDataEx")
	mov AImageDirectoryEntryToDataEx,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("ImageDirectoryEntryToDataEx")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("ImageNtHeader")
	mov AImageNtHeader,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("ImageNtHeader")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("ImageRvaToSection")
	mov AImageRvaToSection,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("ImageRvaToSection")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("ImageRvaToVa")
	mov AImageRvaToVa,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("ImageRvaToVa")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("ImagehlpApiVersionEx")
	mov AImagehlpApiVersionEx,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("ImagehlpApiVersionEx")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("MakeSureDirectoryPathExists")
	mov AMakeSureDirectoryPathExists,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("MakeSureDirectoryPathExists")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("MapDebugInformation")
	mov AMapDebugInformation,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("MapDebugInformation")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("MiniDumpReadDumpStream")
	mov AMiniDumpReadDumpStream,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("MiniDumpReadDumpStream")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("MiniDumpWriteDump")
	mov AMiniDumpWriteDump,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("MiniDumpWriteDump")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SearchTreeForFile")
	mov ASearchTreeForFile,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SearchTreeForFile")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("StackWalk")
	mov AStackWalk,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("StackWalk")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("StackWalk64")
	mov AStackWalk64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("StackWalk64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymAddSymbol")
	mov ASymAddSymbol,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymAddSymbol")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymCleanup")
	mov ASymCleanup,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymCleanup")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymDeleteSymbol")
	mov ASymDeleteSymbol,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymDeleteSymbol")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumLines")
	mov ASymEnumLines,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumLines")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumSourceFiles")
	mov ASymEnumSourceFiles,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumSourceFiles")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumSourceLines")
	mov ASymEnumSourceLines,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumSourceLines")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumSym")
	mov ASymEnumSym,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumSym")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumSymbols")
	mov ASymEnumSymbols,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumSymbols")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumSymbolsForAddr")
	mov ASymEnumSymbolsForAddr,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumSymbolsForAddr")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumTypes")
	mov ASymEnumTypes,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumTypes")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumerateModules")
	mov ASymEnumerateModules,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumerateModules")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumerateModules64")
	mov ASymEnumerateModules64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumerateModules64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumerateModulesW64")
	mov ASymEnumerateModulesW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumerateModulesW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumerateSymbols")
	mov ASymEnumerateSymbols,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumerateSymbols")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumerateSymbols64")
	mov ASymEnumerateSymbols64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumerateSymbols64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymEnumerateSymbolsW64")
	mov ASymEnumerateSymbolsW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymEnumerateSymbolsW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymFindFileInPath")
	mov ASymFindFileInPath,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymFindFileInPath")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymFromAddr")
	mov ASymFromAddr,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymFromAddr")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymFromIndex")
	mov ASymFromIndex,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymFromIndex")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymFromName")
	mov ASymFromName,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymFromName")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymFromToken")
	mov ASymFromToken,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymFromToken")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymFunctionTableAccess")
	mov ASymFunctionTableAccess,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymFunctionTableAccess")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymFunctionTableAccess64")
	mov ASymFunctionTableAccess64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymFunctionTableAccess64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetFileLineOffsets64")
	mov ASymGetFileLineOffsets64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetFileLineOffsets64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetHomeDirectory")
	mov ASymGetHomeDirectory,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetHomeDirectory")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineFromAddr")
	mov ASymGetLineFromAddr,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineFromAddr")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineFromAddr64")
	mov ASymGetLineFromAddr64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineFromAddr64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineFromAddrW64")
	mov ASymGetLineFromAddrW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineFromAddrW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineFromName")
	mov ASymGetLineFromName,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineFromName")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineFromName64")
	mov ASymGetLineFromName64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineFromName64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineFromNameW64")
	mov ASymGetLineFromNameW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineFromNameW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineNext")
	mov ASymGetLineNext,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineNext")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineNext64")
	mov ASymGetLineNext64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineNext64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLineNextW64")
	mov ASymGetLineNextW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLineNextW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLinePrev")
	mov ASymGetLinePrev,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLinePrev")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLinePrev64")
	mov ASymGetLinePrev64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLinePrev64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetLinePrevW64")
	mov ASymGetLinePrevW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetLinePrevW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetModuleBase")
	mov ASymGetModuleBase,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetModuleBase")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetModuleBase64")
	mov ASymGetModuleBase64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetModuleBase64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetModuleInfo")
	mov ASymGetModuleInfo,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetModuleInfo")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetModuleInfo64")
	mov ASymGetModuleInfo64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetModuleInfo64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetModuleInfoW64")
	mov ASymGetModuleInfoW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetModuleInfoW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetScope")
	mov ASymGetScope,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetScope")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSearchPath")
	mov ASymGetSearchPath,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSearchPath")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSourceFile")
	mov ASymGetSourceFile,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSourceFile")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSourceFileFromToken")
	mov ASymGetSourceFileFromToken,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSourceFileFromToken")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSourceFileToken")
	mov ASymGetSourceFileToken,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSourceFileToken")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSourceVarFromToken")
	mov ASymGetSourceVarFromToken,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSourceVarFromToken")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymFromAddr")
	mov ASymGetSymFromAddr,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymFromAddr")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymFromAddr64")
	mov ASymGetSymFromAddr64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymFromAddr64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymFromName")
	mov ASymGetSymFromName,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymFromName")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymFromName64")
	mov ASymGetSymFromName64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymFromName64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymNext")
	mov ASymGetSymNext,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymNext")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymNext64")
	mov ASymGetSymNext64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymNext64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymPrev")
	mov ASymGetSymPrev,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymPrev")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymPrev64")
	mov ASymGetSymPrev64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymPrev64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetSymbolFile")
	mov ASymGetSymbolFile,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetSymbolFile")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetTypeFromName")
	mov ASymGetTypeFromName,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetTypeFromName")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetTypeInfo")
	mov ASymGetTypeInfo,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetTypeInfo")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymGetTypeInfoEx")
	mov ASymGetTypeInfoEx,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymGetTypeInfoEx")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymInitialize")
	mov ASymInitialize,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymInitialize")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymLoadModule")
	mov ASymLoadModule,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymLoadModule")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymLoadModule64")
	mov ASymLoadModule64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymLoadModule64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymLoadModuleEx")
	mov ASymLoadModuleEx,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymLoadModuleEx")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymMatchFileName")
	mov ASymMatchFileName,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymMatchFileName")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymMatchStringA")
	mov ASymMatchStringA,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymMatchStringA")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymNext")
	mov ASymNext,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymNext")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymPrev")
	mov ASymPrev,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymPrev")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymRegisterCallback")
	mov ASymRegisterCallback,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymRegisterCallback")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymRegisterCallback64")
	mov ASymRegisterCallback64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymRegisterCallback64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymRegisterCallbackW64")
	mov ASymRegisterCallbackW64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymRegisterCallbackW64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymRegisterFunctionEntryCallback")
	mov ASymRegisterFunctionEntryCallback,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymRegisterFunctionEntryCallback")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymRegisterFunctionEntryCallback64")
	mov ASymRegisterFunctionEntryCallback64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymRegisterFunctionEntryCallback64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSearch")
	mov ASymSearch,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSearch")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSetContext")
	mov ASymSetContext,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSetContext")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSetHomeDirectory")
	mov ASymSetHomeDirectory,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSetHomeDirectory")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSetOptions")
	mov ASymSetOptions,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSetOptions")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSetParentWindow")
	mov ASymSetParentWindow,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSetParentWindow")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSetSearchPath")
	mov ASymSetSearchPath,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSetSearchPath")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSrvDeltaName")
	mov ASymSrvDeltaName,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSrvDeltaName")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSrvGetFileIndexString")
	mov ASymSrvGetFileIndexString,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSrvGetFileIndexString")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSrvGetFileIndexes")
	mov ASymSrvGetFileIndexes,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSrvGetFileIndexes")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSrvGetSupplement")
	mov ASymSrvGetSupplement,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSrvGetSupplement")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSrvIsStore")
	mov ASymSrvIsStore,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSrvIsStore")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSrvStoreFile")
	mov ASymSrvStoreFile,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSrvStoreFile")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymSrvStoreSupplement")
	mov ASymSrvStoreSupplement,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymSrvStoreSupplement")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymUnDName")
	mov ASymUnDName,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymUnDName")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymUnDName64")
	mov ASymUnDName64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymUnDName64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymUnloadModule")
	mov ASymUnloadModule,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymUnloadModule")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("SymUnloadModule64")
	mov ASymUnloadModule64,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("SymUnloadModule64")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("UnDecorateSymbolName")
	mov AUnDecorateSymbolName,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("UnDecorateSymbolName")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("UnmapDebugInformation")
	mov AUnmapDebugInformation,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("UnmapDebugInformation")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("WinDbgExtensionDllInit")
	mov AWinDbgExtensionDllInit,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("WinDbgExtensionDllInit")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("block")
	mov Ablock,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("block")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("dbghelp")
	mov Adbghelp,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("dbghelp")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("fptr")
	mov Afptr,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("fptr")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("homedir")
	mov Ahomedir,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("homedir")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("lmi")
	mov Almi,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("lmi")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("lminfo")
	mov Alminfo,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("lminfo")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("omap")
	mov Aomap,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("omap")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("srcfiles")
	mov Asrcfiles,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("srcfiles")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("stack_force_ebp")
	mov Astack_force_ebp,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("stack_force_ebp")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("stackdbg")
	mov Astackdbg,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("stackdbg")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("sym")
	mov Asym,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("sym")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("symsrv")
	mov Asymsrv,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("symsrv")
			mov retour,0
			jmp surechec
		.endif

	invoke GetProcAddress,Hlibrairie,SADD("vc7fpo")
	mov Avc7fpo,eax
		.if eax == 0
			invoke RetrouveMessageErreur, SADD("vc7fpo")
			mov retour,0
			jmp surechec
		.endif	
	
;-----------------------------------------------------

	;la fonction se deroule dans le contexte de l'application
	;c'est a dire qu'en cas de dbordement de pile,il n'y a plus de parachute
	;la solution consiste a install une page de garde pour pouvoir continuer
	;la gestion des exceptions
	invoke GetModuleHandle, NULL
	mov HExceptInstance,eax		;vite d'utiliser l'instance de l'application
	;et de se rfrer a sa variable.La boite d'affichage utilise le handle d'instance
	;deux fois ,comme parente et fentre principale	
	invoke SetUnhandledExceptionFilter,offset FINAL_HANDLER
	mov oldHandler,eax
	invoke InitialisationSymboles
	mov excPresenceSymboles,eax	
	.if eax == 0
		invoke RetrouveMessageErreur, SADD("chec de InitialisationSymboles")
		mov retour,0
		jmp surechec
	.endif
	jmp FindeInstalleExceptions
	surechec:
	invoke FreeLibrary,Hlibrairie
 FindeInstalleExceptions:
         mov eax,retour
         ret
InstalleExceptions endp

; #########################################################################

end