
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

	MEMHEAP STRUCT
		Hheap dd ?	;Handle heap,GetProcessHeap
		Pheap dd ?	;Pointeur heap,HeapAlloc
		Theap dd ?	;taille du bloc Heap
	MEMHEAP ENDS
      PuPo MACRO M1, M2
        push M2
        pop  M1
      ENDM	
	;	WriteToMemHeap PROTO  :DWORD,  :DWORD,  :DWORD 
	comment 
	s'occupe de toute la gestion heap,et se comporte comme un tampon disque
	La gestion de mmoire est dynamique,et on peut envoyer autant de chaines
	que l'on veut,on ne peut pas en retirer.
	dmarrer ---> MEMHEAP tout a 0,chaine existante,taille ventuelle
			si la taille est nulle,la chaine doit se terminer par un zero
			Si on a dja appeler la fonction pour un autre bloc,on peut
			renseigner  MEMHEAP.Hheap
			La fonction cre le handle de heap,le pointeur heap si ceux ci
			n'existent pas
			ex:invoke WriteToMemHeap,addr Blocheap,addr phrase1,NULL
			la taille du tampon et le pointeur sont actualiss
	ajouter ----> ex:invoke WriteToMemHeap,addr Blocheap,addr phrase2,NULL
	librer bloc -----> ex:invoke WriteToMemHeap,addr Blocheap,NULL,NULL
			le pointeur Pheap est remis a zero,on peut rutiliser MEMHEAP
			le handle reste actif,fonctionnement normal
	
	
      ; -------------------------------------------------------------------
      ; Les fichiers inclus ii ,AUCUN .lib c'est au programme utilisateur
      ;	de les fournir
      ; -------------------------------------------------------------------
       include \masm32\include\windows.inc
       include \masm32\include\kernel32.inc

      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------

      ; 
      ;exemples de definitions externes
      ; 	EXTERNDEF Copier :PROTO  :DWORD,:DWORD
      ; 	EXTERNDEF EtatMemoirePile :MEMORY_BASIC_INFORMATION 
      ; 	EXTERNDEF PoriginePile:DWORD		
		EXTERNDEF RetrouveMessageErreur : PROTO  :DWORD	
	
   .data	
erreurhandleheap db "WriteToMemHeap GetProcessHeap",0
erreurPointeheap db "WriteToMemHeap HeapAlloc",0
erreurHeapReAlloc db "WriteToMemHeap HeapReAlloc",0
erreurHeapFree db "WriteToMemHeap HeapFree",0
    .code
;################################################################
WriteToMemHeap PROC  AdrStruct:DWORD,  adrChaine:DWORD,  Taille:DWORD 
			Local   longueur:DWORD
			LOCAL   PointeurEcriture:DWORD
			;Local    [MAX_PATH +1]:BYTE 
			Local  retour:DWORD
	Pushad
	mov esi,AdrStruct	
	;------------ vrifier la validit des arguments ---------------
	;-----adrChaine NULL , librer le tampon
	.if adrChaine == 0 && Taille == 0
		.if dword ptr [esi][MEMHEAP.Pheap] != 0
			invoke HeapFree,dword ptr [esi][MEMHEAP.Hheap],NULL,dword ptr [esi][MEMHEAP.Pheap]
			.if eax == NULL
				invoke RetrouveMessageErreur,addr erreurHeapFree
				mov retour,0
				jmp FindeWriteToMemHeap
			.endif		
			xor eax,eax
			mov dword ptr [esi][MEMHEAP.Pheap],eax
			mov dword ptr [esi][MEMHEAP.Theap],eax
			mov retour,1
		.else
			mov retour,0
		.endif
		jmp FindeWriteToMemHeap
	.endif
	;---- taille de la chaine a crire,si NULL ,rechercher sa longueur
	.if Taille == 0
		invoke lstrlen,adrChaine
		mov longueur,eax
		.if eax == 0
			mov retour,0
			jmp FindeWriteToMemHeap	;rien  crire
		.endif
	.else
		PuPo longueur,Taille
	.endif
	;---- handle heap
	.if dword ptr [esi][MEMHEAP.Hheap] == 0	;pas de handle,le crer
		invoke GetProcessHeap
		mov   dword ptr [esi][MEMHEAP.Hheap],eax
		.if eax == NULL
			invoke RetrouveMessageErreur,addr erreurhandleheap
			mov retour,0
			jmp FindeWriteToMemHeap
		.endif
	.endif
	;---- pointeur heap
	.if dword ptr [esi][MEMHEAP.Pheap] == 0
		mov edx,longueur
		inc edx	;pour le zero
		invoke HeapAlloc,dword ptr [esi][MEMHEAP.Hheap],HEAP_ZERO_MEMORY,edx
		.if eax == 0
			invoke RetrouveMessageErreur,addr erreurPointeheap
			mov retour,0
			jmp FindeWriteToMemHeap			
		.endif
		mov dword ptr [esi][MEMHEAP.Pheap],eax
		mov eax,longueur
		mov dword ptr [esi][MEMHEAP.Theap],eax
		;---- crire la premire donne pour viter de rajouter de la mmoire inutile
		mov ecx,longueur
		mov edi,dword ptr [esi][MEMHEAP.Pheap]
		mov esi,adrChaine
		cld
		rep movsb
		mov retour,1
		jmp FindeWriteToMemHeap
		
	.endif
	;tout est valide et une premiere opration d'criture  dja t faite
	mov edx,dword ptr [esi][MEMHEAP.Theap]
	mov eax,longueur
	add edx,eax
	inc edx		;totale des donnes + le zero
	invoke HeapReAlloc,dword ptr [esi][MEMHEAP.Hheap],HEAP_ZERO_MEMORY,\
				dword ptr [esi][MEMHEAP.Pheap],edx
	.if eax == 0
		invoke RetrouveMessageErreur,addr erreurHeapReAlloc
		mov retour,0
		jmp FindeWriteToMemHeap					
	.endif
	;l'ventuel nouveau pointeur
	mov dword ptr [esi][MEMHEAP.Pheap],eax
	;la nouvelle taille
	mov edx,dword ptr [esi][MEMHEAP.Theap]
	mov PointeurEcriture,edx			;le dcalage  l'criture
	mov eax,longueur
	add edx,eax
	;inc edx		;totale des donnes sans le zero	
	mov dword ptr [esi][MEMHEAP.Theap],edx
	;recopier les donnes
	mov edi,dword ptr [esi][MEMHEAP.Pheap]
	add edi,PointeurEcriture
	mov ecx,longueur
	mov esi,adrChaine
	cld
	rep movsb	
       mov retour,1
 FindeWriteToMemHeap:
	popad
       mov eax,retour
         ret
WriteToMemHeap endp

; #########################################################################

end