
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

      ; --------------------------------
      ; Les fichiers inclus ii
      ; --------------------------------
       include \masm32\include\windows.inc
      ; include \masm32\include\gdi32.inc
       include \masm32\include\user32.inc
      	include \masm32\include\kernel32.inc
       include \masm32\include\masm32.inc
	include macros.txt
      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------
	EXTERNDEF LecturePile :PROTO :DWORD
	EXTERNDEF EtatMemoirePile :MEMORY_BASIC_INFORMATION 
	EXTERNDEF memoirepile :MEMORY_BASIC_INFORMATION 
	EXTERNDEF Copier :PROTO  :DWORD,:DWORD
	EXTERNDEF sysinfo:SYSTEM_INFO
	EXTERNDEF PoriginePile:DWORD			
	EXTERNDEF ToriginePile:DWORD			
	EXTERNDEF RetrouveMessageErreur :PROTO :DWORD
	EXTERNDEF szBaseAddress:BYTE
	EXTERNDEF szAllocationBase:BYTE
	EXTERNDEF textpile:BYTE
	EXTERNDEF sztaillepile:BYTE
	EXTERNDEF TnouvellePile:DWORD
	EXTERNDEF persolibtampon:BYTE ;:MAX_PATH
	EXTERNDEF PnouvellePile:DWORD


      ; 
    .data
	szdiminutionpile db "Diminution de la pile",0	

    .code
;################################################################

DiminuerPile PROC  NbpagesMem:DWORD,Affichage:DWORD 
			Local  retour:DWORD
			Local  adrRegion:DWORD
			Local  TailleRegion:DWORD
			Local  Tampon[100]:BYTE
	;calculer le nombre de pages de la region
	invoke LecturePile,0
	.if eax == 0
		mov retour,0
		jmp FindeDiminuerPile
	.endif
	
	mov eax,EtatMemoirePile.RegionSize
	mov ecx,sysinfo.dwPageSize
	xor edx,edx
	div ecx		;eax contient le nombre de pages de la zone
	.if eax > NbpagesMem    ;le nb de pages de la region est > au nombre a enlever
		;tout va bien
		jmp @F
	.else
		mov retour,0
		jmp FindeDiminuerPile
	.endif 
	@@:

	;calculer la quantit de byte a librer
	mov eax,sysinfo.dwPageSize
	mov ecx,NbpagesMem ;envoy par l'utilisateur
	xor edx,edx
	mul ecx
	mov edx,eax
	mov retour,edx ;pas trop normal
	invoke VirtualFree,EtatMemoirePile.BaseAddress,edx,MEM_DECOMMIT
	.if eax == 0
		InsTxt persopile031, "VirtualFree failed"	
		invoke RetrouveMessageErreur, ADDR persopile031	; la boite de message
		mov retour,0
		jmp FindeDiminuerPile
	.endif
	mov edx,retour
	;calculer la nouvelle adresse de base
	mov eax,EtatMemoirePile.BaseAddress
	add eax,edx
	mov edx,eax
	;test
	;retrouve les informations sur la region de la pile
	invoke VirtualQuery,edx,addr memoirepile,sizeof memoirepile 
	.if eax == 0
		InsTxt persopile030, "VirtualQuery diminue failed"		; Nom de la fonction ayant echou
		invoke RetrouveMessageErreur, ADDR persopile030	; la boite de message
		mov retour,0
		jmp FindeDiminuerPile
	.else
		mov retour,eax ;nb de bytes crit dans la structure
		PuPo PoriginePile,memoirepile.BaseAddress
		PuPo PnouvellePile,memoirepile.BaseAddress
		PuPo ToriginePile,memoirepile.RegionSize
		PuPo TnouvellePile,memoirepile.RegionSize
		.if Affichage == 1		
			;affichage des rsultats
			invoke Copier,addr persolibtampon,addr szdiminutionpile
			mov edx,eax
			add edx,ecx		
			invoke Copier,edx,addr szBaseAddress
			mov edx,eax
			add edx,ecx		
			invoke dwtoa,memoirepile.BaseAddress,edx
			invoke lnstr,addr persolibtampon
			lea edx,persolibtampon
			add edx,eax
			invoke Copier,edx,addr szAllocationBase
			mov edx,eax
			add edx,ecx
			invoke dwtoa,memoirepile.AllocationBase,edx				
			;deuxieme ligne messagebox
			invoke Copier,addr Tampon,addr textpile
			mov edx,eax
			add edx,ecx	
			invoke dwtoa,esp,edx	
			invoke lnstr,addr Tampon
			lea edx,Tampon
			add edx,eax
			invoke Copier,edx,addr sztaillepile
			mov edx,eax
			add edx,ecx
			invoke dwtoa,memoirepile.RegionSize,edx
			invoke MessageBox,NULL,addr Tampon,ADDR persolibtampon,MB_OK
		.endif
	.endif

 FindeDiminuerPile:
         mov eax,retour
         ret
DiminuerPile endp


end