
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

      ; --------------------------------
      ; Les fichiers inclus ii
      ; --------------------------------
       include \masm32\include\windows.inc
      ; include \masm32\include\gdi32.inc
       include \masm32\include\user32.inc
      	include \masm32\include\kernel32.inc
       include \masm32\include\masm32.inc
	include macros.txt
      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------
	EXTERNDEF EtatMemoirePile :MEMORY_BASIC_INFORMATION 
	EXTERNDEF RetrouveMessageErreur :PROTO :DWORD
	EXTERNDEF LecturePile :PROTO :DWORD
	EXTERNDEF PoriginePile:DWORD			
	EXTERNDEF ToriginePile:DWORD			
	EXTERNDEF TnouvellePile:DWORD
	EXTERNDEF sysinfo:SYSTEM_INFO
	EXTERNDEF persolibtampon:BYTE ;:MAX_PATH
	EXTERNDEF Copier :PROTO  :DWORD,:DWORD
	EXTERNDEF szBaseAddress:BYTE
	EXTERNDEF szAllocationBase:BYTE
	EXTERNDEF sztaillepile:BYTE
	EXTERNDEF textpile:BYTE
	EXTERNDEF LibTampon:BYTE
		
      ; 
    .data
	memoirepile MEMORY_BASIC_INFORMATION <>
	szAugmenterpile db "Augmentation de la pile : ",0
		

    .code

;################################################################
AgrandirPile PROC uses esi edi ebx NbpagesMem:DWORD ,Affichage:DWORD
			Local  retour:DWORD
			Local  adrRegion:DWORD
			Local  TailleRegion:DWORD
			Local  Tampon[100]:BYTE
			Local  PageAlloue:DWORD
			LOCAL  Tempmemorybasic:MEMORY_BASIC_INFORMATION
	;Bug Windows ?.dans un projet sans fentre ,VirtualQuery refuse
	;de fonctionner si on ne place pas la structure MEMORY_BASIC_INFORMATION en local
	;----------------Toujours vrifier le rsultat ------------------------------
	;--------------- autres comportement possible createthread 	----------------------
			
       mov retour,1
	;retrouve les informations sur la zone pile existante
	invoke LecturePile,0
	;recopier la rponse,a cause du bug
	lea esi,EtatMemoirePile
	lea edi,Tempmemorybasic
	mov ecx,sizeof MEMORY_BASIC_INFORMATION
	cld
	rep movsb

	;
	invoke VirtualQuery,EtatMemoirePile.BaseAddress,addr Tempmemorybasic,sizeof Tempmemorybasic 
	.if eax == 0
		InsTxt pileMsgERR000, "VirtualQuery start failed"		; Nom de la fonction ayant echou
		invoke RetrouveMessageErreur, ADDR pileMsgERR000	; la boite de message
		ret
	.else
		PuPo PoriginePile,Tempmemorybasic.BaseAddress
		PuPo ToriginePile,Tempmemorybasic.RegionSize
		PuPo TnouvellePile,sysinfo.dwPageSize
		.if Affichage == 1
		;permet de vrifier que esp se trouve bien dans la plage BaseAddress +4096
		invoke Copier,addr LibTampon,addr szBaseAddress
		mov edx,eax
		add edx,ecx		
		invoke dwtoa,Tempmemorybasic.BaseAddress,edx
		invoke lnstr,addr LibTampon
		lea edx,LibTampon
		add edx,eax
		invoke Copier,edx,addr szAllocationBase
		mov edx,eax
		add edx,ecx
		invoke dwtoa,Tempmemorybasic.AllocationBase,edx				
		;deuxieme ligne messagebox
		invoke Copier,addr Tampon,addr textpile
		mov edx,eax
		add edx,ecx	
		invoke dwtoa,esp,edx	
		invoke lnstr,addr Tampon
		lea edx,Tampon
		add edx,eax
		invoke Copier,edx,addr sztaillepile
		mov edx,eax
		add edx,ecx
		invoke dwtoa,Tempmemorybasic.RegionSize,edx
		invoke MessageBox,NULL,addr Tampon,ADDR LibTampon,MB_OK
		.endif
	.endif
	
	;trouver les rfrences de la nouvelle rgion a allouer
	;l'adresse de base de la nouvelle rgion = ad region origine - (Nb de pages a allou -1)
	;calcul le nombre de pages alloues
	mov eax,Tempmemorybasic.RegionSize
	mov ecx,sysinfo.dwPageSize
	xor edx,edx
	div ecx
	mov PageAlloue,eax
	.if eax < NbpagesMem
		;tout va bien
		jmp @F    ;continuer
	.else
		mov retour,0
		jmp FindeAgrandirPile
	.endif
	@@:
	mov eax,sysinfo.dwPageSize
	mov ecx,NbpagesMem
	sub ecx,PageAlloue
	mul ecx
	mov edx,PoriginePile
	sub edx,eax			
	invoke VirtualQuery,edx,addr Tempmemorybasic,sizeof Tempmemorybasic 
	.if eax == 0
		InsTxt pileMsgERR102, "VirtualQuery nouvelle rfrence failed"		; Nom de la fonction ayant echou
		invoke RetrouveMessageErreur, ADDR pileMsgERR102	; la boite de message
		ret
	.else
		;		
		PuPo PoriginePile,Tempmemorybasic.BaseAddress
		PuPo ToriginePile,Tempmemorybasic.RegionSize
		PuPo TnouvellePile,sysinfo.dwPageSize
		comment 
		invoke Copier,addr LibTampon,addr szAugmenterpile
		mov edx,eax
		add edx,ecx
		invoke Copier,edx,addr szBaseAddress
		mov edx,eax
		add edx,ecx		
		invoke dwtoa,Tempmemorybasic.BaseAddress,edx
		invoke lnstr,addr LibTampon
		lea edx,LibTampon
		add edx,eax
		invoke Copier,edx,addr szAllocationBase
		mov edx,eax
		add edx,ecx
		invoke dwtoa,Tempmemorybasic.AllocationBase,edx				
		;deuxieme ligne messagebox
		invoke Copier,addr Tampon,addr textpile
		mov edx,eax
		add edx,ecx	
		invoke dwtoa,esp,edx	
		invoke lnstr,addr Tampon
		lea edx,Tampon
		add edx,eax
		invoke Copier,edx,addr sztaillepile
		mov edx,eax
		add edx,ecx
		invoke dwtoa,Tempmemorybasic.RegionSize,edx
		invoke MessageBox,NULL,addr Tampon,ADDR LibTampon,MB_OK
		
	.endif
	;allouer cette portion de mmoire Tempmemorybasic.BaseAddress
	mov edx,Tempmemorybasic.RegionSize
	add edx,4096		;inclure la page d'origine dans le lot,c'est possible
	invoke VirtualAlloc,Tempmemorybasic.BaseAddress,edx,\
			MEM_COMMIT or MEM_TOP_DOWN	,PAGE_READWRITE	
			
	.if eax == 0
		InsTxt pileMsgERR001, "VirtualAlloc ++ failed"	
		invoke RetrouveMessageErreur, ADDR pileMsgERR001	; la boite de message
		;invoke MessageBox,NULL,SADD("Failed"),SADD("VirtualAlloc"),MB_OK
		mov retour,0
		jmp FindeAgrandirPile 
	.else
		;recopier la rponse,a cause du bug
		lea edi,memoirepile
		lea esi,Tempmemorybasic
		mov ecx,sizeof MEMORY_BASIC_INFORMATION
		cld
		rep movsb
			
	.endif
	
			;un programme ne peut verrouill que 30 pages MAX
		;en cas de dpassement de ce nombre , comportement trange du proc
		;++++++++++++++++   mfiance +++++++++++++++++++++++++++++++++++++
		;invoke VirtualLock,PnouvellePile,30*4096 ;
		;.if eax == 0
		;	InsTxt pileMsgERR005, "VirtualLock failed"		; Nom de la fonction ayant echou
		;	invoke RetrouveMessageErreur, ADDR pileMsgERR000	; la boite de message
		;	ret
		;.endif
				
 FindeAgrandirPile:
         mov eax,retour
         ret
AgrandirPile endp

end