
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

      ; --------------------------------
      ; Les fichiers inclus ii
      ; --------------------------------
       include \masm32\include\windows.inc
      ; include \masm32\include\gdi32.inc
      ; include \masm32\include\user32.inc
      ; include \masm32\include\masm32.inc
	 include macros.txt
      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------
	EXTERNDEF LongZtexte:PROTO  :DWORD,:DWORD

      ; 

    .code


; ########################################################################
ChercherMotBornes proc Debut:DWORD,AdrPerdu:DWORD,AdrChercher:DWORD,Methode:DWORD,\
			AdrAutoriseAvant:DWORD,AdrAutoriseApres:DWORD
			
; syntaxe Methode comme VB ,0 binaire,1 texte 
; demarre Debut a 1 signifie au premier caractere
; retour eax position relative premier carac. de la chaine trouv  comme VB
; eax 0 pas trouv ou divers incidents 
; limite de recherche 256 0 ou 0Dh
;

	Local LongCont       :DWORD
	Local PointCont      :DWORD
	Local LongCherche    :DWORD
	Local DeplaceMax     :DWORD
	local retour         :DWORD 
	Local Position	:DWORD
	
	Pushad  
	
	mov retour,1	;par dfaut russite
	mov eax,Debut
	mov Position,eax
	;---------------------- controles des paramtres --------------------------
	.if eax < 1
		mov retour,0
		jmp FindechercherMot
	.endif	
	invoke LongZtexte,AdrPerdu,MAX_PATH +1

	.if eax < 1
		mov retour,0
		jmp FindechercherMot
	.endif
	mov LongCont,eax	
	invoke LongZtexte,AdrChercher,MAX_PATH + 1
	.if eax < 1
		mov retour,0
		jmp FindechercherMot
	.else
	mov LongCherche,eax
	mov ecx,LongCont
	cmp eax,ecx
	jle ValidData
	mov retour,0
	jmp FindechercherMot			
	.endif
			
	;la chaine de recherche doit etre <= en taille a l'autre
ValidData: 
	;la position de depart+long cherche =< long contenant si = deplace =0 ecx,1
	;------- vrifier que la chaine est contenu dans ce qui reste
	mov eax, Position        ;relatif a la chaine
	add eax,LongCherche	     ;longueur de la chaine cherche
	dec eax		     
	.if eax > LongCont
		mov retour,0
		jmp FindechercherMot
	.endif
	mov ecx,LongCont
	inc ecx           ;sinon -1 en sortie pour zero dep
	sub ecx,eax
	mov DeplaceMax,ecx ;nombre de dplacements possible du pointeur de recherche

	; les donnes sont valides 
	;InsTxt Message," les donnes sont valides",0 
	;INVOKE     MessageBox, Hwnd, addr Message, addr titre, MB_YESNO 

	cld
	PuPo PointCont,Position
	dec  PointCont        
	mov esi,AdrPerdu
	add esi,Position           ;1 car pointeur 0
	dec esi		     ;esi chaine contenant + position de depart -1
	dec esi                  ;est incremente de nouveau par progresse contenant
	mov edi,AdrChercher        ;di sur contenu ?
ProgresseAdrPerdu:
	inc esi
	inc PointCont           ;position de trouver 
	xor ebx,ebx
	xor eax,eax
	xor edx,edx             ;dl byte cherche
ProgresseContenu:
	mov al,byte ptr [esi+ebx]
	.if Methode == 1        ;en majuscules
		.if eax > 96 && eax < 123
			sub al,32
		.endif
	.endif
	mov dl,byte ptr [edi+ebx]
	.if Methode ==1        ;en majuscules
		.if edx > 96 && edx < 123
			sub dl,32
		.endif
	.endif

	inc ebx
	cmp al,dl
	jnz NegatifResult 
	cmp ebx,LongCherche
	jnz ProgresseContenu   ;continu la comparaison
	jmp ChaineTrouve
NegatifResult:
	dec DeplaceMax     ;decremente compteur dep
	jnz ProgresseAdrPerdu
	mov retour,0		;pas trouv
	jmp FindechercherMot
ChaineTrouve:
	mov eax,PointCont     ;trouv a quel position
	mov retour,eax	;//////////////// chaine identique trouv /////////////////////////////
	mov Position,eax
	;-------------- le mot vrifie t'il les conditions d'encadrement ?
	;------- les tampons d'encadrements doivent tre termins par 0,zero valide
	;------------------- limite basse -----------------------------------------
	mov esi,AdrPerdu
	.if Position == 1
		jmp limiteSup		;dbut de phrase , condition basse accepte
	.endif
	add esi,Position
	sub esi,2
	mov al,[esi]
	mov edi,AdrAutoriseAvant
	;---------------------------------------------------------------------------
	;-------- compar al aux caractres de la liste
	mov dl,[edi]
	.if dl == 0
		jmp limiteSup      ;il n'y a pas de limite basse,accept
	.endif
	@@:
	mov dl,[edi]
	.if al == dl
		jmp limiteSup	     ;identique accept
	.else
		inc edi
		mov dl,[edi]
		.if dl == 0
			mov eax,LongCherche		;refus,la liste a t parcouru sans succs
			add Position,eax
			jmp ValidData
		.endif
		jmp @B
	.endif
	;------------------------------ limite suprieur ---------------------------
	limiteSup:
	mov eax,Position
	dec eax
	add eax,LongCherche	
	.if eax > LongCont
		jmp FindechercherMot		;en bout de phrase , chaine valide
	.endif
	;--------
	mov esi,AdrPerdu
	add esi,Position
	dec esi
	add esi,LongCherche
	mov al,[esi]
	.if al == 0
		;autoris d'office; fin de phrase
		jmp FindechercherMot
	.endif
	mov edi,AdrAutoriseApres
	mov dl,[edi]
	.if dl == 0
		jmp FindechercherMot      ;il n'y a pas de limite haute,chaine valide
	.endif
	@@:
	mov dl,[edi]
	.if al == dl
		jmp FindechercherMot	     ;identique , chaine valide
	.else
		inc edi
		mov dl,[edi]
		.if dl == 0
			mov eax,LongCherche		;refus,la liste a t parcouru sans succs
			add Position,eax
			jmp ValidData
		.endif
		jmp @B
	.endif
	

FindechercherMot: 
popad
mov eax,retour     
ret

ChercherMotBornes endp

; #########################################################################

end