			comment ?
scan le fichier a la recherche des lignes ASCII 
utilise la structure INFOSTEXTASCII 
preserve tous les registres sauf eax, fonction 3 idem 2 + charge esi (pointeur ligne) ecx (long ligne) 
retourne 1 conforme fichier texte ,0 checs divers affichage si non ascii

+++++++++++ tache 1 (sur 4) Nb total de lignes,terminaison fichier par 0D0A ou non, ascii ou binaire
		initialisation,doit trouver un fichier ouvert en mmoire
		cre une zone mmoire pour conserver les rsultats
		 procde en deux tapes
		1 recherche le nombre de lignes
		cre le tampon mmoire correspondant au nombre de lignes
	       et recherche les informations sur longueur

++++++++++ tache 2 renvoi le pointeur d'un numero de ligne ainsi que sa longueur, 0D0A non compris
++++++++++ tache 3 idem a deux + charge esi,debut phrase ,ecx longueur
++++++++++ tache 4 vide les tampons mmoires,ferme l'ventuel fichier de sortie ouvert
la tache 10 est interne et consiste a mmoriser les pointeurs et longueurs de lignes


INFOSTEXTASCII struct
	Hfichier      dd 0            ;handle,pointeur et taille du fichier texte en mmoire
	Pfichier      dd 0
	Tfichier      dd 0
	NBlignesODOA  dd 0		   ;-------nb de lignes avec 0D0A	
	NBlignes      dd 0		   ;-------nb de lignes sans 0D0A	,max 1
	NumeroLigne   dd 0		   ; numero de ligne voulue	
	LenLigne      dd 0            ;------- sans le 0D0A
	Pligne        dd 0		   ;------- pointeur de la ligne
	InfoODOA      dd 0            ;--------Format normal avec 0D0A ,oui 1 s'applique a la ligne ou au fichier
	Tache         dd 0		   ;la tache voulue de 1  4	
	Hresultat     dd 0             ;------- handle,pointeur et taille tampon mmoire rsultat
	Presultat     dd 0
	Tresultat     dd 0
	Hsortie       dd 0		   ;handle ventuelle de fichier de sortie
INFOSTEXTASCII ends

Optimiser ,2 scrutations plus rapide que de faire appel a la memoire dynamique (catastrophe)
plus de loop ,supression du controle inutile (10) 110 120 ms sur 3 Mo

				?

; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

      ; --------------------------------
      ; Les fichiers inclus ii
      ; --------------------------------
       include \masm32\include\windows.inc
      ; include \masm32\include\gdi32.inc
       include \masm32\include\user32.inc
       include \masm32\include\kernel32.inc
      ; include \masm32\include\masm32.inc
	 include macros.txt
      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------

      ; 

    .code
;################################################################
ScrutationFichierTexte PROC InfoT:DWORD 
	Local  PointePhrase:DWORD         ;contient le point derniere phrase
	Local  CompteurODOA:DWORD
	Local  Compteur:DWORD
	Local  retour:DWORD
	local  PointeResultat:DWORD

	INFO TEXTEQU <(INFOSTEXTASCII ptr [esi])>
	;tache 10 memo ligne dans global 
	
	pushad 
	mov esi,InfoT
	call controle			;positionne edx sur la tache
	.if eax == 0
		jmp FindeScrutationFichierTexte
	.endif
	
	;------------------------------ debut des taches --------------------------------------
	.if edx == 4    ;tout vider
		call purger
		jmp FindeScrutationFichierTexte
	.endif
;-------------------------------------------------------------------------------------------------

		mov esi,InfoT
		ScrutationDeux: 
		mov CompteurODOA,0     ;compteur de lignes compltes
		mov Compteur,0	  ;compteur de lignes sans 0D0Ah	
	
       .if dword ptr INFO.Tache == 1 || \
		 dword ptr INFO.Tache == 10       ;scan total
		;------- prparer l'init -----------------------
       		mov dword ptr INFO.NBlignesODOA,0         
		mov dword ptr INFO.NBlignes,0             
		mov dword ptr INFO.NumeroLigne,0   	 
		mov dword ptr INFO.LenLigne,0             
       	mov dword ptr INFO.Pligne,0               
       	mov dword ptr INFO.InfoODOA,0	
		;on n'a besoin , a la premiere passe que de 
		;CompteurODOA  et de Compteur pour calculer la taille de mmoire ncessaire
	 
       		.if dword ptr INFO.Tache == 10        
              		push edi
				mov edi,PointeResultat
                         	mov edx,INFO.Pfichier
              		mov [edi],edx            ;pointeur 1 phrase  
              		pop edi
			.else
				call passeUne		;gain de temps 20 ms sur 120 130,plus regulier
				jmp ScrutationTermine					
			.endif
           
       .elseif dword ptr INFO.Tache == 2 || \
			dword ptr INFO.Tache == 3
		;--------- charger les infos lignes----------
		.if dword ptr INFO.NumeroLigne < 1
			mov retour,0
			jmp FindeScrutationFichierTexte
		.endif
		mov edx,INFO.NBlignes
		add edx,INFO.NBlignesODOA
		.if dword ptr INFO.NumeroLigne > edx
			mov retour,0
			jmp FindeScrutationFichierTexte
		.endif		
		;le numro de ligne est valide
		mov edi,INFO.Presultat   ;charge le pointeur de resultat
		mov eax,INFO.NumeroLigne ;le numero de ligne
		dec eax
		mov ecx,8
		xor edx,edx
		mul ecx
		add edi,eax        
		mov eax,[edi] 
		mov INFO.Pligne,eax
		mov eax,[edi+4] 
		mov INFO.LenLigne,eax
		mov retour,1
		jmp FindeScrutationFichierTexte
	.endif 
	;-----------------------------------------------------------------------------------------
      ;------------------------------- deuxime scrutation ------------------------------------
	;------------------------------------------------------------------------------------------
	mov edi,INFO.Pfichier
	PuPo PointePhrase,edi
	mov ecx,INFO.Tfichier
	
	AutrePhrase:	
	mov eax,13
	@@:
	repnz scasb			;rien de plus rapide
	.if ecx != 0
		;compter la longueur de la phrase
		push edi
		push ecx
		;-------------------------------------
		inc edi			;pour pointer aprs le 13,10
		mov edx,edi                 
		sub edx,PointePhrase		
		sub edx,2			 ;calcul longueur	sans 0D0A
		inc   CompteurODOA          ;InfoT.NBlignes     + 1 ligne       
		push edi
		push ebx
		mov ebx,edi
		mov edi,PointeResultat              ;info longueur
		mov [edi+4],edx		
		add  PointeResultat,8    
		mov edi,PointeResultat     ;cycle normal deuxieme 
		mov [edi],ebx              ;info pointeur ligne suivante
		pop ebx
		pop edi
		PuPo PointePhrase,edi
		;---------------------------------------------
		pop ecx
		pop edi
		jmp AutrePhrase 			
	.else     ;ecx = 0 la fin de fichier peut comporter un 0D,non compt cmp
            ;le fichier peut tre constitu d'une ligne max 256 caractres
            ;sans retour ligne,pas de vrifications de la nature des octets
	     ;la derniere ligne ne pourra galement compter que 256 carctres sans retour ligne	
            mov edx,INFO.Tfichier    
		.if CompteurODOA == 0 &&  edx > 256	;erreur
			pasasciiechec:
         		invoke GlobalUnlock,INFO.Presultat
         		invoke GlobalFree,INFO.Hresultat
                  	invoke MessageBox,NULL,SADD("Fichier non ASCII"),SADD("Erreur Grave"),MB_OK                    		
			mov retour,0
			jmp  FindeScrutationFichierTexte
		.else
		;verifier que edi n'tait pas arriver en fin d'une ligne pleine
			dec edi
			mov al,[edi]
			.if al != 10		;ne pas recompter une ligne				
				mov dword ptr INFO.InfoODOA,0    ;le fichier ne se termine pas pas 0D0A
				sub  edi,PointePhrase             ;calcul la long
				mov  edx,edi
				push edi
				mov edi,PointeResultat	;sauvegarde taille en mmoire
				mov [edi +4],edx
				pop edi
				inc   Compteur		
			.endif
		.endif
		jmp  ScrutationTermine      ;operation termin avec succs    
	.endif	

       
 ScrutationTermine: ;++++++++++++++ pour le deuxieme passage ++++++++++++++

.if dword ptr INFO.Tache == 1
;cre le tampon mmoire
		mov dword ptr INFO.Tache,10
		mov eax,CompteurODOA
		add eax,Compteur
		mov ecx,8               ;4 bytes * 2 (pointeur ,taille)
		xor edx,edx
		mul ecx

		.if edx != 0	;trop grossse mmoire
			mov retour,0
			jmp FindeScrutationFichierTexte
		.endif
		mov INFO.Tresultat,eax
		mov ecx,eax
		invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_ZEROINIT,ecx					
		.if eax==0
			InsTxt aPetiteMem,"Pas assez de place mmoire ScrutationFichierTexte",0
			invoke  MessageBox,NULL,ADDR aPetiteMem,SADD("GlobalAlloc"),MB_OK
			mov retour,0
			jmp FindeScrutationFichierTexte	;chec
		.endif        
		
		mov  INFO.Hresultat,eax
		;obtenir le pointeur de memoire
		invoke GlobalLock,dword ptr INFO.Hresultat
		.if eax==0
			InsTxt aPetitep,"erreur pointeur memoire ",0
			invoke  MessageBox,NULL,ADDR aPetitep,SADD("GlobalLock"),MB_OK
			mov retour,0
			jmp FindeScrutationFichierTexte	;chec
		.endif        
 		mov  INFO.Presultat,eax
		mov  PointeResultat,eax  ; pour la deuxieme scrutation
		jmp  ScrutationDeux    ;enregistr maintenant les infos pointeurs et tailles lignes

.elseif dword ptr INFO.Tache == 10        ;init scrutation
	PuPo INFO.NBlignesODOA,CompteurODOA
	PuPo INFO.NBlignes,Compteur
	mov retour, 1                    ;succs
.endif
FindeScrutationFichierTexte:
	PoPad
	push ebx
	mov ebx,InfoT
	.if dword ptr (INFOSTEXTASCII ptr [ebx]).Tache == 3
		mov esi,(INFOSTEXTASCII ptr [ebx]).Pligne
		mov ecx,(INFOSTEXTASCII ptr [ebx]).LenLigne
	.endif
	pop ebx
	
	mov eax,retour	
	ret
;----------------------------------------- sub ------------------------------------------------
passeUne:
mov edi,INFO.Pfichier
mov ecx,INFO.Tfichier	;
mov eax,13
@@:
repnz scasb
.if ecx != 0
	inc CompteurODOA
	jmp short @B
.else
	;les deux conditions peuvent tomber simultanment ,thorie edi pointe sur zero
	dec edi
	mov al,[edi]
	.if al != 10
		inc  Compteur     ;ne pas compter deux fois la mme ligne
	.endif
.endif

RETN

controle:
	.if dword ptr INFO.Tfichier <= 2 ;Taille fichier trop petite
		mov eax,0
		mov retour,0
		retn
	.endif
	mov edx,INFO.Tache
	.if edx > 0 && edx < 5           ;tache compris entre 1 et 4
	       mov eax,1	;OK
	.else
		mov eax,0
		mov retour,0
	.endif
retn	
purger:
	mov esi,InfoT
	mov edx,INFO.Pfichier
	.if edx != 0
		invoke GlobalUnlock,edx
		mov edx,INFO.Hfichier
		invoke GlobalFree,edx
		.if eax != 0				
			invoke MessageBox,NULL,SADD("GlobalFree Hfichier failed,exception gnr"),
					SADD("ScrutationFichierTexte "),MB_OK
		.endif
	.endif						
	
	mov edx,INFO.Presultat
	.if edx != 0
		invoke GlobalUnlock,edx
		mov edx,INFO.Hresultat
		invoke GlobalFree,edx
		.if eax != 0				
			invoke MessageBox,NULL,SADD("GlobalFree Hresultat failed,exception gnr"),
					SADD("ScrutationFichierTexte "),MB_OK
		.endif
	.endif
	mov edx,INFO.Hsortie	
	.if edx != 0
		invoke  CloseHandle,edx
		.if eax == 0				
			invoke MessageBox,NULL,SADD("CloseHandle Hsortie failed,exception gnr"),
					SADD("ScrutationFichierTexte "),MB_OK
		.endif			
	.endif		
	invoke RtlZeroMemory,InfoT,sizeof INFOSTEXTASCII
	mov retour,1
retn

ScrutationFichierTexte endp
; #########################################################################

end