
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

      ; --------------------------------
      ; Les fichiers inclus ii
      ; --------------------------------
       include \masm32\include\windows.inc
      ; include \masm32\include\gdi32.inc
       include \masm32\include\user32.inc
      	include \masm32\include\kernel32.inc
       include \masm32\include\masm32.inc
	include macros.txt
      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------
	EXTERNDEF RetrouveMessageErreur :PROTO :DWORD
	EXTERNDEF Copier :PROTO  :DWORD,:DWORD
      ; 
    .data
	EtatMemoirePile MEMORY_BASIC_INFORMATION <>
	BlocMemoire dd 0
	PoriginePile dd 0
	ToriginePile dd 0
	PnouvellePile dd 0
	TnouvellePile dd 0
	sysinfo SYSTEM_INFO <>
	sztaillepile db " ,Taille de la pile = ",0
	szAllocationBase db ", AllocationBase = ",0
	szBaseAddress db "BaseAddress = ",0
	szlecturezone db "lecture de la zone pile : ",0
	textpile	db "ESP = ",0
	LibTampon	db  500 dup (0)
	persolibtampon db MAX_PATH dup (0)
	persolibphrase db MAX_PATH dup (0)	
    .code

;################################################################
;en entre l'adresse d'une structure MEMORY_BASIC_INFORMATION
;destine uniquement a la lecture et non pas a conserver des infos sur l'tar de la pile
;le but est de faire une recherche dans l'espace rserve de la pile
;pour dterminer l'espace allou ou non
;VirtualQuery ne voit que les pages situs au dessus de esp et la page contenant esp
;elle fournit l'adresse de base de la page contenant esp sans examiner les pages infrieurs

LecturePile PROC uses esi edi ebx Affichage:DWORD  
			Local  retour:DWORD
			Local  adrRegion:DWORD
			Local  TailleRegion:DWORD
			Local  Tampon[100]:BYTE
			LOCAL  BaseTemp:DWORD
			LOCAL  TailleMemTemp:DWORD
			LOCAL  Tempmemorybasic:MEMORY_BASIC_INFORMATION
	;Bug Windows ?.dans un projet sans fentre ,VirtualQuery refuse
	;de fonctionner si on ne place pas la structure MEMORY_BASIC_INFORMATION en local
	;----------------Toujours vrifier le rsultat ------------------------------
	;--------------- autres comportement possible createthread 	----------------------
	
       mov retour,1
	invoke GetSystemInfo,addr sysinfo ;SYSTEM_INFO	
	;retrouve les informations sur la region de la pile
	PuPo BaseTemp,esp
	;premiere lecture , tat partiel de la rgion vu par VirtualQuery
	invoke VirtualQuery,BaseTemp,addr Tempmemorybasic,sizeof Tempmemorybasic
	.if eax == 0 
		InsTxt pileMsgERR041, "chec tat partiel rgion vu par VirtualQuery "		; Nom de la fonction ayant echou
		invoke RetrouveMessageErreur, ADDR pileMsgERR041	; la boite de message
		mov retour,0
		jmp FindeLecturePile
	.else
		PuPo 	BaseTemp,Tempmemorybasic.BaseAddress
		PuPo   TailleMemTemp,Tempmemorybasic.RegionSize

	.endif
	;rajouter une page a cette zone ,si la taille de la zone vu augmente aussi
	;d'une page ,cela veut dire que la mmoire pile continue vers les adresses basses
	;c'est la mthode la plus sure,mme si elle n'est pas ncessaire dans d'autres
	;lectures de mmoire pagine comme la recherche du MZ d'un programme
	lecturezone:
	mov edx,Tempmemorybasic.BaseAddress
	sub edx,sysinfo.dwPageSize
	invoke VirtualQuery,edx,addr Tempmemorybasic,sizeof Tempmemorybasic
	mov edx,TailleMemTemp
	add edx,sysinfo.dwPageSize
	mov eax,Tempmemorybasic.RegionSize
	.if eax == edx   ;on est toujours dans la mme rgion
		PuPo 	BaseTemp,Tempmemorybasic.BaseAddress
		PuPo   TailleMemTemp,Tempmemorybasic.RegionSize
		jmp lecturezone
	.endif
	;affichage du rsultat
	;********************************************************************************************	
	invoke VirtualQuery,BaseTemp,addr Tempmemorybasic,sizeof Tempmemorybasic 
	.if eax == 0
		InsTxt pileMsgERR040, "lecture VirtualQuery failed"		; Nom de la fonction ayant echou
		invoke RetrouveMessageErreur, ADDR pileMsgERR040	; la boite de message
		mov retour,0
		jmp FindeLecturePile
	.else
		;recopier la rponse,a cause du bug
		lea edi,EtatMemoirePile
		lea esi,Tempmemorybasic
		mov ecx,sizeof MEMORY_BASIC_INFORMATION
		cld
		rep movsb
		PuPo PoriginePile,Tempmemorybasic.BaseAddress
		PuPo ToriginePile,Tempmemorybasic.RegionSize
		PuPo TnouvellePile,sysinfo.dwPageSize
		;affichage des rsultats
		.if Affichage == 1
			invoke Copier,addr LibTampon,addr szlecturezone
			mov edx,eax
			add edx,ecx
			invoke Copier,edx,addr szBaseAddress
			mov edx,eax
			add edx,ecx		
			invoke dwtoa,Tempmemorybasic.BaseAddress,edx
			invoke lnstr,addr LibTampon
			lea edx,LibTampon
			add edx,eax
			invoke Copier,edx,addr szAllocationBase
			mov edx,eax
			add edx,ecx
			invoke dwtoa,Tempmemorybasic.AllocationBase,edx				
			;deuxieme ligne messagebox
			invoke Copier,addr Tampon,addr textpile
			mov edx,eax
			add edx,ecx	
			invoke dwtoa,esp,edx	
			invoke lnstr,addr Tampon
			lea edx,Tampon
			add edx,eax
			invoke Copier,edx,addr sztaillepile
			mov edx,eax
			add edx,ecx
			invoke dwtoa,Tempmemorybasic.RegionSize,edx
			invoke MessageBox,NULL,addr Tampon,ADDR LibTampon,MB_OK
		.endif
	.endif

 FindeLecturePile:
         mov eax,retour
         ret
LecturePile endp

;################################################################

end